<img src="https://raw.githubusercontent.com/tlnagy/TiffImages.jl/b4f946b75caae33992eb818551230ded7a9aa9de/docs/src/assets/fulllogo.svg" width="500">

_"Don't get into a tiff with your images"_

| **Stable release** | **Documentation**                 | **Build Status**                                              |
|:------------------------------------------------------|:-------------------------------------------------------------------------|:--------------------------------------------------------------|
| ![](https://juliahub.com/docs/TiffImages/version.svg) | [![][docs-stable-img]][docs-stable-url][![][docs-dev-img]][docs-dev-url] | [![][status-img]][status-url] [![][ci-img]][ci-url] [![][codecov-img]][codecov-url] [![][aqua-img]][aqua-url] |

This package aims to be a fast, minimal, and correct TIFF reader and writer
written in Julia.

## Features

- Fast reading and writing of many common TIFFs
- Extensible core for other TIFF packages to build on
- Native integration with `Colors.jl` and the Julia Array ecosystem
- Memory-mapping for loading images too large to fit in memory
- BigTIFF standard (TIFFs larger than 4 GB)
- Arbitrary bit depths (e.g. 12 or 14 bit cameras)
- Common compression algorithms like LZW and Packbits

## Installation

`TiffImages.jl` is available through Julia's general repository. You can install
it by running the following commands in the Julia REPL:

```julia
using Pkg
Pkg.install("TiffImages")
```

Please see the documentation above for usage details and examples

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://tamasnagy.com/TiffImages.jl/stable

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://tamasnagy.com/TiffImages.jl/dev

[ci-img]: https://github.com/tlnagy/TiffImages.jl/workflows/CI/badge.svg
[ci-url]: https://github.com/tlnagy/TiffImages.jl/actions

[codecov-img]: https://codecov.io/gh/tlnagy/TiffImages.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/tlnagy/TiffImages.jl

[status-img]: https://www.repostatus.org/badges/latest/active.svg
[status-url]: https://www.repostatus.org/#active

[aqua-img]: https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg
[aqua-url]: https://github.com/JuliaTesting/Aqua.jl

# ---
# title: Writing ImageJ compatible metadata
# description: This demo shows how to write XYZT information that works with ImageJ
# author: Donghoon Lee, Tamas Nagy
# cover: assets/fiji_logo.png
# ---

# ImageJ is a commonly used image processing software for working with TIFFs.
# You might want to add X and Y resolution information to your `TiffImages.jl`
# TIFFs that works with ImageJ. 

# First, we need to assign the resolution unit by adding a `RESOLUTIONUNIT` tag
# to each IFD in the image

using Images, TiffImages, Unitful
img0 = zeros(Gray{N0f8}, 10, 10, 12) #example image
img = TiffImages.DenseTaggedImage(img0)

!isdefined(Main, :ifds) && (ifds = x-> x.ifds) #hide

resunit = UInt8(3) # 1: No absolute unit of measurement, 2: Inch, 3: Centimeter
[ifd[TiffImages.RESOLUTIONUNIT] = resunit for ifd in ifds(img)];

# Then, we can add the `XRESOLUTION` and `YRESOLUTION` TIFF tags to store the
# number of pixels per `RESOLUTIONUNIT`. 

resxy = Rational{UInt32}(round(1u"cm"/0.653u"μm", digits = 3)) # Type must be rational. In this example, the pixel size is 0.653 μm x 0.653 μm.
[ifd[TiffImages.XRESOLUTION] = resxy for ifd in ifds(img)]
[ifd[TiffImages.YRESOLUTION] = resxy for ifd in ifds(img)]
first(ifds(img))

# Now if we want to add Z and time information to a TIFF, it's a bit more
# complicated because the TIFF spec doesn't have a standard way of representing
# this information. ImageJ has a poorly documented way to add this information
# by writing to an IMAGEDESCRIPTION tag in the first IFD. 

# The following tells ImageJ that it is a hyperstack with 3 timepoints and 4 Z
# slices with a 0.2 interval (in secs) between frames and a 5 micron spacing,
# respectively. 

first(ifds(img))[TiffImages.IMAGEDESCRIPTION] = # only in the first IFD
"ImageJ=1.51d
images=12
frames=3
slices=4
hyperstack=true
spacing=5.0
unit=um
finterval=0.2
axes=TZYX"

first(ifds(img))

# Then write the image to disk

TiffImages.save("imagej.tiff", img)

# Opening the file in ImageJ shows that it's recognized as a hyperstack with the
# proper XYZT information:

# ![](assets/fiji_hyperstack.png)
# ![](assets/fiji_properties.png)

@testset "Unspecified type" begin
    tf = TiffImages.TiffFile{UInt32}()

    write(tf, UInt16(TiffImages.IMAGEWIDTH))
    write(tf, 0x0007)
    write(tf, UInt32(2))
    write(tf, UInt16[8, 1])

    seekstart(tf.io)
    tag = read(tf, TiffImages.Tag)
    @test tag == TiffImages.Tag(TiffImages.IMAGEWIDTH, Any[8, 0, 1, 0])
    @test sizeof(tag) == 4
end

@testset "Data array only part of data field" begin
    tf = TiffImages.TiffFile{UInt64}()

    write(tf, UInt16(TiffImages.BITSPERSAMPLE))
    write(tf, 0x0003)
    write(tf, UInt64(2))
    write(tf, UInt16[8, 8])
    write(tf, UInt32(0))

    seekstart(tf.io)
    tag = read(tf, TiffImages.Tag)
    @test length(tag.data) == 2 # not 4
    @test sizeof(tag) == 4 # number of bytes is still 2*2
end

@testset "Rational, full space" begin
    tf = TiffImages.TiffFile{UInt64}()
    write(tf, UInt16(TiffImages.XRESOLUTION))
    write(tf, 0x0005)
    write(tf, UInt64(1))
    ratio = Rational{UInt32}(1, 20)
    write(tf, ratio)

    seekstart(tf.io)
    tag = read(tf, TiffImages.Tag)
    @test tag.data == ratio
    @test sizeof(tag) == 8 # two UInt64s 
end

@testset "Additional sizeof tests" begin
    tag = TiffImages.Tag(TiffImages.IMAGEDESCRIPTION, "test")
    @test sizeof(tag) == 5 # 4 bytes + NUL terminator
end

"""
    $(TYPEDEF)

In-memory representation of Tiff Tags, which are essentially key value pairs.
The `data` field can either be a `String`, a `Number`, an Array of bitstypes, or
a [`RemoteData`](@ref) type.

$FIELDS
"""
struct Tag{T}
    tag::UInt16
    data::T
end

Tag(tag::TiffTag, data) = Tag(UInt16(tag), data)
Tag(tag::UInt16, data::String) = Tag{String}(tag, data)
Tag(tag::UInt16, data::T) where {T <: Enum} = Tag{UInt16}(tag, UInt16(data))
function Tag(tag::UInt16, data::AbstractVector{T}) where {T}
    if length(data) == 1
        Tag{T}(tag, first(data))
    else
        Tag{Vector{T}}(tag, data)
    end
end

function Base.getproperty(t::Tag{T}, f::Symbol) where {T}
    if f === :data
        isa(t, Tag{Vector{UInt32}}) ? getfield(t, :data)::Vector{UInt32} :
        isa(t, Tag{Vector{UInt16}}) ? getfield(t, :data)::Vector{UInt16} :
        isa(t, Tag{Vector{UInt8}})  ? getfield(t, :data)::Vector{UInt8} :
        isa(t, Tag{UInt32})         ? getfield(t, :data)::UInt32 :
        isa(t, Tag{UInt16})         ? getfield(t, :data)::UInt16 :
        isa(t, Tag{UInt8})          ? getfield(t, :data)::UInt8 :
        isa(t, Tag{Int64})          ? getfield(t, :data)::Int64 :
        getfield(t, :data)
    else
        getfield(t, :tag)::UInt16
    end
end

function Base.getproperty(t::Tag{<: AbstractString}, f::Symbol)
    if f === :data
        # strip NUL terminators from the end of strings
        strip(getfield(t, :data)::String, '\0')
    else
        getfield(t, :tag)::UInt16
    end
end
Base.getproperty(t::Tag{<: RemoteData}, f::Symbol) = (f == :data) ? error("Data hasn't been loaded, use `load!` on this IFD") : getfield(t, f)

isloaded(t::Tag) = true
isloaded(t::Tag{<: RemoteData}) = false

Base.length(t::Tag{<: AbstractVector}) = length(t.data)
Base.length(t::Tag{<: AbstractString}) = (endswith(t.data, '\0') ? ncodeunits(t.data) : ncodeunits(t.data) + 1)
Base.length(t::Tag{<: RemoteData}) = getfield(t, :data).count
Base.length(t::Tag) = 1

Base.eltype(::Tag{T}) where {T} = T
Base.eltype(::Tag{<: AbstractVector{T}}) where {T} = T
Base.eltype(t::Tag{RemoteData{O, T}}) where {O, T} = T

"""
    sizeof(tag::TiffImages.Tag)

Minimum number of bytes that the _data_ in `tag` will use on disk.

!!! note 
    Actual space on disk will be different because the tag's representation depends on
    the file's offset. For example, given a 2 bytes of data in `tag` and a file with
    `UInt32` offsets, the actual usage on disk will be `sizeof(UInt32)=4` for the
    data + tag overhead
"""
Base.sizeof(t::Tag{T}) where {T} = bytes(T) * length(t)

load(::TiffFile, t::Tag) = t

function load(tf::TiffFile{O}, t::Tag{RemoteData{O, T}}) where {O <: Unsigned, T}
    t_data = getfield(t, :data)
    N = t_data.count
    nb = bytes(T)::Int
    rawdata = Vector{UInt8}(undef, nb*N)

    pos = position(tf.io)
    seek(tf, t_data.position)
    read!(tf, rawdata)

    # if this datatype is comprised of multiple bytes and this file needs to be
    # bitswapped then we'll need to reverse the byte order inside each datatype
    # unit
    if tf.need_bswap && nb >= 2
        reverse!(rawdata)
        data = Array{T}(reverse(reinterpret(T, rawdata)))
    elseif T == String
        data = String(rawdata)
    elseif T == Any
        data = Array{Any}(rawdata)
    else
        data = Array{T}(reinterpret(T, rawdata))
    end

    if N == 1
        data = first(data)
    end
    seek(tf, pos)

    Tag(t.tag, data)::Tag
end

bytes(x::Type) = sizeof(x)
bytes(::Type{Any}) = 1
bytes(::Type{String}) = 1
bytes(::Type{RemoteData{O, T}}) where {O, T} = bytes(T)
bytes(::Type{<: AbstractVector{T}}) where {T} = bytes(T)

function Base.read(tf::TiffFile{O}, ::Type{Tag}) where O <: Unsigned
    tag = read(tf, UInt16)
    datatype = read(tf, UInt16)
    count = read(tf, O)
    data = Vector{UInt8}(undef, sizeof(O))
    read!(tf, data)

    T = Any
    if datatype in keys(tiff_to_julian)
        T = tiff_to_julian[datatype]
    end

    nbytes = bytes(T)::Int * count
    if nbytes <= sizeof(O)
        if tf.need_bswap
            reverse!(view(data, 1:nbytes))
        end
        if T === String
            return Tag(tag, String(data))
        elseif T === Any
            return Tag(tag, Vector{Any}(data))
        elseif count == 1
            return Tag(tag, first(reinterpret(T, data)))::Tag
        else
            return Tag(tag, reinterpret(T, data)[1:Int(count)])
        end
    else
        (tf.need_bswap) && reverse!(data)
        return Tag(tag, RemoteData(first(reinterpret(O, data)), T, count))
    end
end

_showdata(io::IO, t::Tag{RemoteData{O, T}}) where {O, T} = print(io, "REMOTE@$(getfield(t, :data).position) $(T)[] len=$(getfield(t, :data).count)")
_showdata(io::IO, t::Tag{<: AbstractString}) = print(io, "\"", first(t.data, 20), (length(t.data) > 20) ? "..." : "", "\"")
_showdata(io::IO, t::Tag{<: AbstractVector}) = print(io, "$(eltype(t.data))[", join(t.data[1:min(5, end)], ", "), (length(t.data) > 5) ? ", ..." : "", "]")
_showdata(io::IO, t::Tag) = print(io, t.data)

function Base.show(io::IO, t::Tag)
    print(io, "Tag(")
    try
        print(io, TiffTag(t.tag), ", ")
    catch
        print(io, "UNKNOWN($(Int(t.tag))), ")
    end
    if t.tag == Int(COMPRESSION)
        print(io, CompressionType(t.data))
    else
        _showdata(io, t)
    end
    print(io, ")")
end

"""
    write(tf, t)

Write tag `t` to the tiff file `tf`. Returns `true` if the tag data fit
entirely in the IFD space and was written to disk. Otherwise it returns false.
"""
function Base.write(tf::TiffFile{O}, t::Tag{T}) where {O <: Unsigned, T}
    # if the data are too large to fit then we'll need to skip writing this tag
    # for now until we know the length of the entire IFD
    if sizeof(t) > sizeof(O)
        _writeblank(tf)
        return false
    end

    data = t.data
    # add NUL terminator to the end of Strings that don't have it already
    if T === String
        data = data::SubString{String}
        if !endswith(data, '\0')
            data *= "\0"
        end
    end

    write(tf, t.tag)
    write(tf, julian_to_tiff[eltype(t)])
    write(tf, O(length(t)))
    nbytes = write(tf.io, data)::Int

    # write padding
    if nbytes < sizeof(O)
        write(tf, fill(0x00, sizeof(O) - nbytes))
    end
    true
end

function Base.write(tf::TiffFile{O}, t::Tag{RemoteData{O, T}}) where {O <: Unsigned, T}
    write(tf, t.tag)
    write(tf, julian_to_tiff[T])
    t_data = getfield(t, :data)
    write(tf, t_data.count)
    write(tf, t_data.position)
    true
end


function Base.write(tf::TiffFile{O}, t::Tag, offset) where {O <: Unsigned}
    write(tf, Tag(t.tag, RemoteData(O(offset), eltype(t), O(length(t)))))
end

# Base.write(tf::TiffFile, t::Tag) = error("Tag offsets must agree with file offsets")

function _writeblank(tf::TiffFile{O}) where O
    write(tf, UInt32(0))
    write(tf, zero(O))
    write(tf, zero(O))
end

const tagfields = fieldnames(Tag)
function Base.:(==)(t1::Tag{O1}, t2::Tag{O2}) where {O1, O2}
    return O1 == O2 && getproperty.(Ref(t1), tagfields) == getproperty.(Ref(t2), tagfields)
end

@testset "Extant File lazyio" begin
    filepath = get_example("julia.tif")
    img = TiffImages.load(filepath, lazyio=true)
    @test size(img) == (300, 500, 1)
    @test all(img[3, 1:50] .== RGB{N0f8}(1, 1, 1))
    c = img[70,65]   # in the blue dot
    @test blue(c) > max(red(c), green(c))
    # force close the stream behind the file to see if it's properly reopened
    close(img.data.file.io)
    @test all(img[3, 1:50] .== RGB{N0f8}(1, 1, 1))

    # TODO: inefficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt == img.data
    @test img_cvt !== img.data
end

@testset "Extant File mmap" begin
    filepath = get_example("flagler.tif")
    let img = TiffImages.load(filepath, mmap=true)
        @test eltype(img) === TiffImages.WidePixel{RGB{N0f8}, Tuple{N0f8}}
        @test size(img) === (200, 541)
        p = img[34, 105]
        @test green(p.color) > blue(p.color) > red(p.color)
        @test p.extra == (1.0,)
        p = img[61, 218]
        @test red(p.color) > blue(p.color) > green(p.color)
        @test_throws BoundsError img[201, 541]
        @test_throws BoundsError img[200, 542]
        @test img[200,541] isa TiffImages.WidePixel{RGB{N0f8}, Tuple{N0f8}}
        imgeager = TiffImages.load(filepath)
        @test img == imgeager

        # Test that attempting to write the mmapped version throws an error,
        # unless we open with write permissions
        imgeager[61, 218] = zero(p)
        @test imgeager[61, 218] === zero(p)
        @test_throws ReadOnlyMemoryError img[61, 218] = zero(p)

        img = TiffImages.load(filepath, mmap=true, mode="r+")
        img[61, 218] = zero(p)
        @test img[61, 218] === zero(p)
        # Put the file back
        img[61, 218] = p
    end

    # 3d
    img0 = rand(Gray{N0f16}, 1000, 1000, 40)
    filepath = tempname() * ".tif"
    TiffImages.save(filepath, img0)
    img1 = TiffImages.load(filepath);
    let img2 = TiffImages.load(filepath; mmap=true), img3 = TiffImages.load(filepath; lazyio=true)
        @test size(img1) == size(img2) == size(img3) == size(img0)
        @test img1[1,2,3] == img2[1,2,3] == img3[1,2,3] == img0[1,2,3]
        c = img0[1,2,3]
        img1[1,2,3] = complement(c)
        @test img1[1,2,3] == complement(c)
        @test_throws ReadOnlyMemoryError img2[1,2,3] = complement(c)
        @test_throws ErrorException img3[1,2,3] = complement(c)
    end

    # with N0f8 (a special case for sizing slice buffers)
    img0 = Gray{N0f8}[0.2 0.4;
                      0   1]
    filepath2 = tempname() * ".tif"
    TiffImages.save(filepath2, img0)
    let img = TiffImages.load(filepath2; mmap=true)
        @test img == img0
    end
end

@testset "De novo construction" begin
    rm("test.tif", force = true)
    img = empty(LazyBufferedTIFF, Gray{N0f8}, "test.tif")

    # a newly initialized file should have every dimension equal to zero and
    # error if accessed
    @test size(img) == (0, 0, 0)
    @test_throws ErrorException img[1, 1, 1]

    push!(img, rand(Gray{N0f8}, 100, 100))
    @test size(img) == (100, 100, 1)
    @test TiffImages.offset(img) == UInt32

    @test_throws AssertionError push!(img, rand(Gray{N0f8}, 99, 99)) # wrong size

    @testset "BigTIFF" begin
        rm("test.btif", force = true)
        img = empty(LazyBufferedTIFF, Gray{N0f8}, "test.btif"; bigtiff = true)

        push!(img, rand(Gray{N0f8}, 100, 100))
        @test size(img) == (100, 100, 1)
        @test TiffImages.offset(img) == UInt64
    end

    img.readonly = true
    @test_throws ErrorException push!(img, rand(Gray{N0f8}, 100, 100))
end

module TiffImages

if isdefined(Base, :Experimental) && isdefined(Base.Experimental, Symbol("@compiler_options"))
    @eval Base.Experimental.@compiler_options optimize=1
end

using ColorTypes
using DocStringExtensions
using FileIO
using FixedPointNumbers
using IndirectArrays
using OffsetArrays
using DataStructures
using PkgVersion
using ProgressMeter
using PrecompileTools: @setup_workload, @compile_workload
using Base.Iterators
using CodecZstd
using Inflate
using UUIDs
using Mmap
using SIMD

const PKGVERSION = @PkgVersion.Version 0

include("enum.jl")
include(joinpath("types", "widepixel.jl"))
include("utils.jl")
include("files.jl")
include("tags.jl")
include("ifds.jl")
include("compression.jl")
include("layout.jl")
include(joinpath("types", "common.jl"))
include(joinpath("types", "dense.jl"))
include(joinpath("types", "strided.jl"))
include(joinpath("types", "lazy.jl"))
include(joinpath("types", "mmapped.jl"))
include("load.jl")

export memmap, LazyBufferedTIFF, ifds, color, nchannels, channel

@deprecate TiffFile(::Type{O}) where O<:Unsigned TiffFile{O}()

@setup_workload begin
    files = filter(x -> endswith(x, ".tif"), readdir(joinpath(@__DIR__, "precomp-tifs", "images"), join = true))
    @compile_workload begin
        for file in files
            TiffImages.load(file)
            TiffImages.load(file; mmap=true)
            TiffImages.load(file; lazyio=true)
        end
    end
end

end # module

@testset "tags" begin
    @testset "exact fit tags" begin
        tf = TiffImages.TiffFile{UInt32}()
        t1 = TiffImages.Tag(UInt16(TiffImages.IMAGEWIDTH), 0x00000200)
        @test write(tf, t1) # should fit so true

        seekstart(tf.io)
        t2 = read(tf, TiffImages.Tag)
        @test t1 == t2
    end

    @testset "small tags" begin
        tf = TiffImages.TiffFile{UInt32}()
        t1 = TiffImages.Tag(UInt16(TiffImages.COMPRESSION), 0x0001)
        @test write(tf, t1) # should fit but needs padding
        @test position(tf.io) == 12 # should be full length

        seekstart(tf.io)
        t2 = read(tf, TiffImages.Tag)
        @test t2.data == 0x0001
    end

    @testset "large tags" begin
        tf = TiffImages.TiffFile{UInt32}()
        offsets = UInt32[8, 129848, 259688, 389528]
        t1 = TiffImages.Tag(UInt16(TiffImages.STRIPOFFSETS), offsets)

        @test !write(tf, t1) # should fail to write into tf since it's too large
        @test position(tf.io) == 12

        data = Array{UInt8}(undef, 12)
        seekstart(tf.io)
        read!(tf.io, data)

        @test all(data .== 0x00)

        seekstart(tf.io)
        @test write(tf, t1, 12)

        seekstart(tf.io)
        t2 = read(tf, TiffImages.Tag)

        # make sure the data field contains our single offset from above
        @test typeof(t2) <: TiffImages.Tag{<: TiffImages.RemoteData}
        @test getfield(t2, :data).position == 12
    end

    @testset "String length equal to offset size" begin
        tf = TiffImages.TiffFile{UInt32}()
        t1 = TiffImages.Tag(TiffImages.SOFTWARE, "test")

        # should fail because it's too large to fit
        @test !write(tf, t1)
        @test position(tf.io) == 12

        t3 = TiffImages.Tag(TiffImages.SOFTWARE, "tes\0")
        seekstart(tf.io)
        @test write(tf, t3)
        @test position(tf.io) == 12

        seekstart(tf.io)
        t4 = read(tf, TiffImages.Tag)

        # Since this is a NUL-terminated string of length 4 it should fit
        @test getfield(t4, :data) == "tes\0"
        @test t4.data == "tes"
    end

    @testset "UTF-8 strings" begin
        ifd = TiffImages.IFD(UInt32)
        ifd[TiffImages.IMAGEDESCRIPTION] = "αβγ" # 2 bytes each, 6 total
        ifd[TiffImages.SOFTWARE] = "∫" # 3 byte character

        tf = TiffImages.TiffFile{UInt32}()
        write(tf, ifd)

        ifd2 = first(tf)
        TiffImages.load!(tf, ifd2)

        @test ifd[TiffImages.SOFTWARE] == ifd2[TiffImages.SOFTWARE]
        @test ifd[TiffImages.IMAGEDESCRIPTION] == ifd2[TiffImages.IMAGEDESCRIPTION] # test remote data utf-8
    end
end

@testset "ifds" begin
    tf = TiffImages.TiffFile{UInt32}()
    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.IMAGEDESCRIPTION] = "Testing IFD read/write"
    ifd[TiffImages.IMAGEWIDTH] = UInt32(512)
    ifd[TiffImages.IMAGELENGTH] = UInt32(512)
    ifd[TiffImages.XRESOLUTION] = Rational{UInt32}(72, 1)
    ifd[TiffImages.COMPRESSION] = TiffImages.COMPRESSION_NONE
    ifd[TiffImages.SAMPLESPERPIXEL] = 1
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.STRIPBYTECOUNTS] = UInt32[512*512]
    ifd[TiffImages.BITSPERSAMPLE] = 8
    ifd[TiffImages.ICCPROFILE] = Any[0x00, 0x00, 0x0b, 0xe8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x6d]

    write(tf, ifd)

    seekstart(tf.io)
    read_ifd, next_ifd = read(tf, TiffImages.IFD)
    
    seekend(tf.io)
    @test sizeof(ifd) == position(tf.io) # predicted size should match actual size
    @test sizeof(read_ifd) == position(tf.io) # unloaded IFDs should also compute properly

    TiffImages.load!(tf, read_ifd)

    @test all(sort(collect(ifd), by = x -> x[1]) .== sort(collect(read_ifd), by = x -> x[1]))
end

@testset "Simple 2D image" begin
    filepath = get_example("house.tif")
    img = TiffImages.load(filepath)

    img2 = TiffImages.DenseTaggedImage(Gray{Float64}.(img.data));
    path, io = mktemp()
    write(io, img2)
    img3 = TiffImages.load(path)
    @test eltype(img3) == Gray{Float64}
end

@testset "3D image" begin
    filepath = get_example("mri.tif")
    img = TiffImages.load(filepath)

    img2 = TiffImages.DenseTaggedImage(RGB{Float64}.(img.data));
    path, io = mktemp()
    write(io, img2)
    img3 = TiffImages.load(path)
    @test eltype(img3) == RGB{Float64}
end

@testset "BigTIFF saving" begin
    filepath = get_example("house.tif")
    img = TiffImages.load(filepath)

    ifd = TiffImages._constructifd(img.data, UInt64);
    img2 = TiffImages.DenseTaggedImage(img.data, ifd)
    path, io = mktemp()
    write(io, img2)
    img3 = TiffImages.load(path)
    @test eltype(img3) == GrayA{N0f8}
end

@testset "DenseTaggedImage with OffsetArray (#46)" begin
    for T in (Gray, RGB)
        data = OffsetArray(rand(T, 10, 10), -1, -1);
        filepath = tempname()
        TiffImages.save(filepath, data)

        data_saveload = TiffImages.load(filepath)
        # the offset is stripped when saving
        @test axes(data_saveload) != axes(data)
        @test data_saveload == collect(data)
    end
end

@testset "DenseTaggedImage with AxisArray" begin
    for T in (Gray, RGB)
        data = AxisArray(rand(Gray, 100, 100, 3), :h, :w)
        filepath = tempname()
        TiffImages.save(filepath, data)

        # the axis information is stripped when saving
        data_saveload = TiffImages.load(filepath)
        @test axes(data_saveload) == axes(data)
        @test data_saveload == collect(data)
    end
end

@testset "save function" begin
    data = rand(RGB{N0f8}, 128, 128)
    filepath = tempname()

    TiffImages.save(filepath, data)
    @test all(data .== TiffImages.load(filepath))
end


@testset "Software tag, issue #60" begin
    filepath = get_example("house.tif")
    img = TiffImages.load(filepath)
    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.SOFTWARE] = "test"

    img2 = TiffImages.DenseTaggedImage(Gray{Float64}.(img.data), ifd);
    path, io = mktemp()
    write(io, img2)
    img3 = TiffImages.load(path)
    @test occursin("test;", ifds(img3)[TiffImages.SOFTWARE].data)
end

@testset "DenseTaggedImage with unusual bit depth (#181)" begin
    filepath = tempname()
    for C in (Gray, RGB)
        for T in (N0f8, N3f5, N4f12, N13f19, N12f52)
            for size in (1,10,100,567)
                data = C{T}.(rand(size, size))
                TiffImages.save(filepath, data)

                data_saveload = TiffImages.load(filepath)

                @test data_saveload.data == data
            end
        end
    end
end

"""
    $(TYPEDEF)

Pixel type used for images with extra (non-alpha) channels

See also [`nchannels`](@ref), [`channel`](@ref), [`color`](@ref)
"""
struct WidePixel{C <: Colorant, X <: Tuple}
    color::C
    extra::X
end

Base.zero(::WidePixel{C, X}) where {C, X} = WidePixel(zero(C), zero.(fieldtypes(X)))

function Base.show(io::IO, x::WidePixel{C,X}) where {C, X}
    if get(io, :compact, false)
        print(io, "WidePixel($(x.color))")
    else
        len = length(x.extra)
        print(io, "WidePixel($(x.color)) + $len extra channel$(len > 1 ? "s" : "")")
    end
end

"""
    RemoteData

A placeholder type to describe the location and properties of remote data that
is too large to fit directly in a tag's spot in the IFD. Calling [`TiffImages.load!`](@ref)
on an IFD object replaces all `RemoteData`s with the respective data.

$(FIELDS)
"""
struct RemoteData{O <: Unsigned, T}
    """Position of this data in the stream"""
    position::O

    """The length of the data"""
    count::O

    function RemoteData(position::O, datatype::DataType, count::O) where {O}
        new{O, datatype}(position, count)
    end
end

Base.position(o::R) where {R <: RemoteData} = Int(o.pos)

const filepattern = r"<file (.*)>"
const fdpattern = r"<fd (.*)>"

"""
    extract_filename(io) -> String

Extract the name of the file backing a stream
"""
function extract_filename(io::IOStream)
    name = String(io.name)
    filename = match(filepattern, name)
    if filename !== nothing
        return String(filename[1])
    elseif match(fdpattern, name) !== nothing
        return ""
    else
        error("Can't extract filename from the given stream")
    end
end
extract_filename(io::Stream) = io.filename

"""
    check_bswap(io::Stream)

Check endianness of TIFF file to see if we need to swap bytes
"""
function need_bswap(io::Stream)
    seekstart(io)
    endianness = String(read(io, 2))
    # check if we need to swap byte order
    bswap = endianness != (ENDIAN_BOM == 0x04030201 ? "II" : "MM")
    return bswap
end

function offsetsize(io::Stream)
    seek(io, 2)
    tiff_version = Array{UInt8}(undef, 2)
    read!(io, tiff_version)
    if tiff_version == [0x2a, 0x00] || tiff_version == [0x00, 0x2a]
        return UInt32
    elseif tiff_version == [0x2b, 0x00] || tiff_version == [0x00, 0x2b]
        offset_bytesize = read(io, UInt16)
        constant = read(io, UInt16)
        return UInt64
    else
        error("Unknown TIFF version")
    end
end

# using rephorm's table from
# https://github.com/rephorm/TIFF.jl/blob/master/tiff.jl#L30
const tiff_to_julian = Dict(
  0x0001 => UInt8,            # CHAR
  0x0002 => String,           # ASCII
  0x0003 => UInt16,           # SHORT
  0x0004 => UInt32,           # LONG
  0x0005 => Rational{UInt32}, # RATIONAL
  0x0006 => Int8,             # SBYTE
  0x0007 => Any,              # UNDEFINED
  0x0008 => Int16,            # SSHORT
  0x0009 => Int32,            # SLONG
  0x000a => Rational{Int32},  # SRATIONAL
  0x000b => Float32,          # FLOAT
  0x000c => Float64,          # DOUBLE
  0x000d => UInt32,           # IFD
  0x0010 => UInt64,           # LONG8
  0x0011 => Int64,            # SLONG8
  0x0012 => UInt64,           # IFD8
)

const julian_to_tiff = Dict(
    UInt8               => 0x0001,   # CHAR
    String              => 0x0002,   # ASCII
    UInt16              => 0x0003,   # SHORT
    UInt32              => 0x0004,   # LONG
    Rational{UInt32}    => 0x0005,   # RATIONAL
    Int8                => 0x0006,   # SBYTE
    Any                 => 0x0007,   # UNDEFINED
    Int16               => 0x0008,   # SSHORT
    Int32               => 0x0009,   # SLONG
    Rational{Int32}     => 0x000a,   # SRATIONAL
    Float32             => 0x000b,   # FLOAT
    Float64             => 0x000c,   # DOUBLE
    UInt64              => 0x0010,   # LONG8
    Int64               => 0x0011,   # SLONG8
)

_bswap(a) = bswap(a)
_bswap(c::Colorant{T, N}) where {T, N} = mapc(bswap, c)
_bswap(p::WidePixel{C, X}) where {C, X} = WidePixel(_bswap(p.color), _bswap(p.extra))
_bswap(t::Tuple) = map(bswap, t)

function getstream(fmt, io, name)
    # adapted from https://github.com/JuliaStats/RDatasets.jl/pull/119/
    if isdefined(FileIO, :action)
        # FileIO >= 1.6
        return Stream{fmt}(io, name)
    else
        # FileIO < 1.6
        return Stream(fmt, io, name)
    end
end

getstream(fmt, io::IOBuffer) = getstream(fmt, io, "")
getstream(fmt, io::IOStream) = getstream(fmt, io, extract_filename(io))
# assume OMETIFF if no format given
getstream(io) = getstream(format"TIFF", io)

@static if Sys.iswindows()
    # Be permissive on windows with eager GC to work around
    # https://github.com/tlnagy/TiffImages.jl/pull/79#discussion_r880478304
    function _safe_open(f, filepath::String, mode="r", args...; kwargs...)
        GC.gc()
        try
            open(f, filepath, mode, args...; kwargs...)
        catch err
            if err isa SystemError
                @warn "failed to open file \"$filepath\" in \"$mode\" mode, this may be caused by overwriting a file previously opened with mmap"
            end
            rethrow()
        end
    end
else
    const _safe_open = open
end

@static if isdefined(Base, :memcpy)
    function memcpy(dest::Ptr{T}, src::Ptr{T}, n::Int) where T
        Base.memcpy(dest, src, n)
    end
else
    function memcpy(dest::Ptr{T}, src::Ptr{T}, n::Int) where T
        ccall(:memcpy, Ptr{T}, (Ptr{T}, Ptr{T}, Int), dest, src, n)
    end
end

using Base: @propagate_inbounds

"""
    $(TYPEDEF)

The most common TIFF structure that associates an Image File Directory, aka
[`TiffImages.IFD`](@ref), with each XY image slice.

```jldoctest; setup = :(using TiffImages, ColorTypes)
julia> img = TiffImages.DenseTaggedImage(Gray.(zeros(UInt8, 10, 10)));

julia> size(img)
(10, 10)

julia> ifds(img)
IFD, with tags: 
	Tag(IMAGEWIDTH, 10)
	Tag(IMAGELENGTH, 10)
	Tag(BITSPERSAMPLE, 8)
	Tag(PHOTOMETRIC, 1)
	Tag(SAMPLESPERPIXEL, 1)
	Tag(SAMPLEFORMAT, 1)

julia> ifds(img)[TiffImages.XRESOLUTION] = 0x00000014//0x00000064 # write custom data
0x00000001//0x00000005

julia> TiffImages.save(mktemp()[2], img); # write to temp file
```

!!! note
    Currently, when writing custom info to tags, play attention to the types
    expected by other TIFF engines. For example,
    [`XRESOLUTION`](https://www.awaresystems.be/imaging/tiff/tifftags/xresolution.html)
    above expects a `rational` by default, which is equivalent to the Julian
    `Rational{UInt32}`

See also [`TiffImages.load`](@ref) and [`TiffImages.save`](@ref)
"""
struct DenseTaggedImage{T, N, O <: Unsigned, AA <: AbstractArray} <: AbstractDenseTIFF{T, N}
    data::AA
    ifds::Vector{IFD{O}}

    function DenseTaggedImage(data::AbstractArray{T, N}, ifds::Vector{IFD{O}}) where {T, N, O}
        if N == 3
            @assert size(data, 3) == length(ifds)
            newifds = _constructifd(data)
        elseif N == 2
            @assert length(ifds) == 1
            newifds = [_constructifd(data, O)]
        end
        new{T, N, O, typeof(data)}(data, map(x->merge(cleanup(x[1]), x[2]), zip(ifds, newifds)))
    end
end

function DenseTaggedImage(data::AbstractArray{T, 2}, ifd::IFD{O}) where {T, O}
    DenseTaggedImage(data, IFD{O}[ifd])
end

DenseTaggedImage(data::AbstractArray{T, 3}) where {T} = DenseTaggedImage(data, _constructifd(data))
DenseTaggedImage(data::AbstractArray{T, 3}, ::Type{O}) where {T, O} = DenseTaggedImage(data, _constructifd(data, O))
DenseTaggedImage(data::AbstractArray{T, 2}) where {T} = DenseTaggedImage(data, [_constructifd(data, UInt32)])
DenseTaggedImage(data::AbstractArray{T, 2}, ::Type{O}) where {T, O} = DenseTaggedImage(data, [_constructifd(data, UInt32)])

Base.size(t::DenseTaggedImage) = size(t.data)
Base.axes(t::DenseTaggedImage) = axes(t.data)

@propagate_inbounds Base.getindex(img::DenseTaggedImage, i...) = getindex(img.data, i...)
@propagate_inbounds Base.setindex!(img::DenseTaggedImage, i...) = setindex!(img.data, i...)
@propagate_inbounds function Base.getindex(img::DenseTaggedImage{T, 3}, i::Colon, j::Colon, k) where {T}
    DenseTaggedImage(getindex(img.data, i, j, k), ifds(img)[k])
end

# Override the fallback convert to get better performance
# ImageIO requires this to get rid of the convert overhead
# Ref: https://github.com/JuliaIO/ImageIO.jl/pull/26
Base.convert(::Type{AA}, img::DenseTaggedImage{T,N,O,AA}) where {T,N,O,AA<:Array} = img.data

"""
    offset(img)

Returns the type of the TIFF file offset. For most TIFFs, it should be UInt32,
while for BigTIFFs it will be UInt64.
"""
offset(::DenseTaggedImage{T, N, O, AA}) where {T, N, O, AA} = O

function _constructifd(data::AbstractArray{T, 3}) where T <: ColorOrTuple
    offset = UInt32
    # this is only a crude estimate for the amount information that we can store
    # in regular TIFF. The real value should take into account the size of the
    # header, the size of a minimal set of tags in each IFDs. 
    if sizeof(T) * length(data) >= typemax(offset)
        @info "Array too large to fit in standard TIFF container, switching to BigTIFF"
        offset = UInt64
    end
    _constructifd(data, offset)
end
"""
    _constructifd(data, offset)

Generate a IFD with the minimal set of tags to describe `data`.
"""
function _constructifd(data::AbstractArray{T, 3}, ::Type{O}) where {T <: ColorOrTuple, O <: Unsigned}
    ifds = IFD{O}[]

    for slice in axes(data, 3)
        push!(ifds, _constructifd(view(data, :, :, slice), O))
    end

    ifds
end

const cleanup_list = [
    EXTRASAMPLES,
    ROWSPERSTRIP,
    PLANARCONFIG,
    SAMPLEFORMAT
]

"""
    Creates a new IFD with a non-exhaustive list of problematic tags removed that 
will mess up the final tiff if they are included. These aren't merged away with the
default set created by `_constructifd`
"""
function cleanup(ifd::IFD{O}) where {O <: Unsigned}
    newifd = IFD(O, copy(ifd.tags))
    for tag in cleanup_list
        delete!(newifd, tag)
    end
    newifd
end

function _constructifd(data::AbstractArray{T, 2}, ::Type{O}) where {T <: ColorOrTuple, O <: Unsigned}
    ifd = IFD(O)

    ifd[IMAGEWIDTH] = UInt32(size(data, 2))
    ifd[IMAGELENGTH] = UInt32(size(data, 1))
    n_samples = samplesperpixel(data)
    ifd[BITSPERSAMPLE] = collect(UInt16.(bitspersample(data)))
    ifd[PHOTOMETRIC] = interpretation(data)
    ifd[SAMPLESPERPIXEL] = UInt16(n_samples)
    if !(T <: Gray{N7f1}) # bilevel images don't have the sampleformat tag
        ifd[SAMPLEFORMAT] = collect(UInt16.(sampleformat(data)))
    end
    extra = extrasamples(data)
    if extra !== nothing
        ifd[EXTRASAMPLES] = UInt16.(extra)
    end
    ifd
end

Base.write(io::IOStream, img::DenseTaggedImage) = write(getstream(format"TIFF", io, extract_filename(io)), img)

function _writeslice(pagecache, tf::TiffFile{O, S}, slice, ifd, prev_ifd_record) where {O, S}
    data_pos = position(tf.io) # start of data
    plain_data_view = reshape(PermutedDimsArray(slice, (2, 1)), :)

    if is_irregular_bps(ifd)
        temp = collect(reinterpret(eltype(interpretation(ifd)), plain_data_view))
        columns = ncols(ifd) * nsamples(ifd)
        pagecache = pack_integers(temp, columns)
    else
        pagecache .= reinterpret(UInt8, plain_data_view)
    end

    write(tf, pagecache) # write data
    ifd_pos = position(tf.io)

    # update record of previous IFD to point to this new IFD
    seek(tf.io, prev_ifd_record)
    write(tf, O(ifd_pos))

    ifd[COMPRESSION] = COMPRESSION_NONE
    ifd[STRIPOFFSETS] = O(data_pos)
    ifd[STRIPBYTECOUNTS] = O(ifd_pos-data_pos)

    version = "$(parentmodule(IFD)::Module).jl v$PKGVERSION"
    if SOFTWARE in ifd
        ifd[SOFTWARE] = "$(ifd[SOFTWARE].data);$version"
    else
        ifd[SOFTWARE] = version
    end

    seek(tf.io, ifd_pos)
    prev_ifd_record = write(tf, ifd)
    seekend(tf.io)
    prev_ifd_record
end

function Base.write(io::Stream, img::I) where {I <: DenseTaggedImage{T, N}} where {T, N}
    O = offset(img)
    tf = TiffFile{O}(io)

    prev_ifd_record = write(tf) # record that will have be updated

    pagecache = Vector{UInt8}(undef, size(img.data, 2) * sizeof(eltype(img.data)) * size(img.data, 1))

    # For offseted arrays, `axes(img, 3) == 1:length(ifds(img))` does not hold in general
    for (idx, ifd) in zip(axes(img, 3), N == 3 ? ifds(img) : [ifds(img)])
        prev_ifd_record = _writeslice(pagecache, tf, view(img, :, :, idx), ifd, prev_ifd_record)
    end

    prev_ifd_record
end

"""
    save(io, data)

Write data to `io`, if data is a `DenseTaggedImage` then any custom tags are
also written to the file, otherwise a minimal set of tags are added to make the
data readable by other TIFF engines.
"""
save(io::IO, data::DenseTaggedImage) where {IO <: Union{IOStream, Stream}} = write(io, data)
save(io::IO, data) where {IO <: Union{IOStream, Stream}} = save(io, DenseTaggedImage(data))
function save(filepath::String, data)
    _safe_open(filepath, "w") do io
        save(getstream(format"TIFF", io, filepath), data)
    end
    nothing
end

Base.push!(A::DenseTaggedImage{T, N, O, AA}, data) where {T, N, O, AA} = error("push! is only supported for memory mapped images. See `LazyBufferedTIFF`.")

pack_integers(A::AbstractVector{<: Normed{T, N}}, columns::Int) where {T, N} = pack_integers(reinterpret(T, A), columns, N)

# {AAXX, BBXX, CCXX} => {AAB, BCC}
function pack_integers(A::AbstractVector{T}, columns::Int, N::Int) where T <: Unsigned
    if N == 8 || N == 16 || N == 32 || N == 64
        return reinterpret(UInt8, A)
    end

    @debug "encoding data"

    rows = cld(length(A), columns)
    out::Vector{UInt8} = Vector{UInt8}(undef, rows * cld(columns * N, 8))
    out_index = 1
    in_index = 1
    mask = (T(1) << N) - 1
    in_length = length(A)
    for _ in 1:rows
        buffer::UInt64 = 0
        bitcount = 0
        values = 0
        while values < columns
            while bitcount < 8 && in_index <= in_length && values < columns
                buffer = Base.shl_int(buffer, N)
                @inbounds buffer = buffer | (A[in_index] & mask)
                bitcount += N
                in_index += 1
                values += 1
                if values == columns && bitcount % 8 != 0
                    buffer = buffer << (8 - (bitcount % 8))
                    bitcount = cld(bitcount, 8) * 8
                end
            end

            while bitcount >= 8
                out[out_index] = convert(UInt8, Base.lshr_int(buffer, bitcount - 8) & 0xff)
                bitcount -= 8
                out_index += 1
            end
        end

        @assert bitcount == 0
    end

    out
end

# # Reading TIFFs

# Loading most TIFFs should just work, see [Writing TIFFs](@ref) for more
# advanced manipulation of TIFF objects. But we'll quickly run through a common
# use cases.

#md # ```@contents
#md # Pages = ["reading.md"]
#md # Depth = 5
#md # ```

get_example(name) = download("https://github.com/tlnagy/exampletiffs/blob/master/$name?raw=true") #hide
filepath = get_example("spring.tif");                                                             #hide

# ### Basic loading

# At its most basic, we can just point `TiffImages.jl` to the filepath of an
# image and it will attempt to load it. Here, we're loading `spring.tif` from
# the [`tlnagy/exampletiffs`](https://github.com/tlnagy/exampletiffs) repo

using TiffImages
img = TiffImages.load(filepath)

# If you're a graphical environment, you can load the `Images.jl` repo to get
# a nice graphical representation of your image. If you're in the REPL, I highly
# recommend the `ImageInTerminal.jl` package for some visual feedback.

# Continuing on, `img` here behaves exactly as you would expect a Julian array
# to despite the funky type signature

typeof(img)

# Everything should behave as expected

eltype(img)

# !!! note
#     If your reaction to this element type is "Whoa! What is that?", I highly
#     recommend reading `JuliaImages`' [primer on colors and
#     types](https://juliaimages.org/stable/tutorials/arrays_colors/).
#     `TiffImages` is well integrated with the `JuliaImages` ecosystem so the
#     tutorials there are quite helpful for learning how to interact with the
#     `TiffImages`' outputs

# Accessing and setting data should work as expected
img[160:180, 50]
#---------
img[160:180, 50] .= 1.0
img

abstract type AbstractTIFF{T,N} <: AbstractArray{T,N} end

abstract type AbstractDenseTIFF{T,N} <: AbstractTIFF{T,N} end

abstract type AbstractStridedTIFF{T,N} <: AbstractTIFF{T,N} end

const ColorOrTuple = Union{WidePixel,Colorant}

function Base.getproperty(img::T, sym::Symbol) where {T<:AbstractTIFF}
    if sym === :ifds
        Base.depwarn("Directly accessing the ifds property is deprecated" *
                     " and will be removed in TiffImages v0.7.0+. Please use `ifds(img)` instead.",
            :AbstractTIFF)
    end
    getfield(img, sym)
end

"""
    ifds(img)

Get the Image File Directories of `img`, see [`TiffImages.IFD`] for details.
Returns a single IFD for a 2D TIFF. Otherwise, returns a list of IFDs with a
length equal to the third dimension of a 3D TIFF.
```
"""
ifds(img::I) where {I<:AbstractTIFF{T,2} where {T}} = first(getfield(img, :ifds))
ifds(img::I) where {I<:AbstractTIFF} = getfield(img, :ifds)

interpretation(img::AbstractArray) = interpretation(eltype(img))
interpretation(::IndirectArray{T,N,I}) where {T,N,I} = PHOTOMETRIC_PALETTE
interpretation(::SubArray{T,N,P}) where {T,N,P<:IndirectArray{X,Y,I}} where {X,Y,I} = PHOTOMETRIC_PALETTE
interpretation(::Type{WidePixel{C,X}}) where {C,X} = interpretation(C)
interpretation(::Type{T}) where {T<:Gray} = PHOTOMETRIC_MINISBLACK
interpretation(::Type{T}) where {T<:AbstractRGB} = PHOTOMETRIC_RGB
interpretation(::Type{<:TransparentColor{C,T,N}}) where {C,T,N} = interpretation(C)
interpretation(::Type) = PHOTOMETRIC_MINISBLACK

samplesperpixel(img::AbstractArray) = samplesperpixel(eltype(img))
samplesperpixel(::IndirectArray{T,N,I}) where {T,N,I} = 1
samplesperpixel(::SubArray{T,N,P}) where {T,N,P<:IndirectArray{X,Y,I}} where {X,Y,I} = 1
samplesperpixel(::Type{<:Colorant{T,N}}) where {T,N} = N
samplesperpixel(t::Type{<:WidePixel{C,X}}) where {C,X} = samplesperpixel(C) + length(fieldnames(X))

bitspersample(img::AbstractArray) = bitspersample(eltype(img))
bitspersample(::IndirectArray{T,N,I}) where {T,N,I} = I <: Integer ? bitspersample(I) : bitspersample(eltype(I)) # I is an integer after IndirectArray v1
bitspersample(::SubArray{T,N,P}) where {T,N,P<:IndirectArray{X,Y,I}} where {X,Y,I} = bitspersample(I)
bitspersample(T::Type{<:WidePixel}) = collect(flatten(bitspersample.(fieldtypes(T))))
bitspersample(T::Type{<:Colorant}) = collect(bitspersample.(fieldtypes(T)))
bitspersample(T::Type{<:Tuple}) = collect(bitspersample.(fieldtypes(T)))
bitspersample(::Type{<:Normed{T,S}}) where {T,S} = S
bitspersample(::Type{<:Fixed{T,S}}) where {T,S} = S + 1
bitspersample(::Type{T}) where T = sizeof(T) * 8

sampleformat(img::AbstractArray) = sampleformat(eltype(img))
sampleformat(T::Type{<:WidePixel}) = collect(flatten(sampleformat.(fieldtypes(T))))
sampleformat(T::Type{<:Colorant}) = collect(sampleformat.(fieldtypes(T)))
sampleformat(T::Type{<:Tuple}) = collect(sampleformat.(fieldtypes(T)))
sampleformat(::Type{<:Normed{T,S}}) where {T,S} = 1
sampleformat(::Type{<:Fixed{T,S}}) where {T,S} = 2
sampleformat(::Type{T}) where T<:AbstractFloat = 3
sampleformat(::Type{Complex{T}}) where T<:Signed = 5
sampleformat(::Type{Complex{T}}) where T<:AbstractFloat = 6

extrasamples(img::AbstractArray) = extrasamples(eltype(img))
extrasamples(T::Type{WidePixel{C,X}}) where {C<:TransparentColor,X} = vcat([1], fill(0, length(fieldtypes(X))))
extrasamples(T::Type{WidePixel{C,X}}) where {C,X} = fill(0, length(fieldtypes(X)))
extrasamples(::Type) = nothing
extrasamples(img::Type{<:TransparentColor}) = 1

"""
    channel(img, i)

Get the `i`'th channel of data from `img`

For example, `channel(img, 2)` would yield the green channel
of an RGB image, or the (unlabeled) second channel of a multispectral
image
"""
channel(img::AbstractTIFF, i::Int) = channel.(img, i)
channel(x::Colorant, i::Int) = getfield(x, i)
channel(x::WidePixel, i::Int) = i <= length(x.color) ? getfield(x.color, i) : x.extra[i-length(x.color)]

_length(x) = length(x)
_length(T::Type{<:Tuple}) = length(fieldnames(T))

"""

    nchannels(img::AbstractTIFF)

Return the number of channels in each pixel

For example, an image with RGB pixels has 3 channels
"""
nchannels(img::AbstractTIFF) = nchannels(eltype(img))
nchannels(img::AbstractArray{<:ColorOrTuple}) = nchannels(eltype(img))
nchannels(x) = _length(x)
nchannels(::Type{WidePixel{C,X}}) where {C,X} = _length(C) + _length(X)
nchannels(::WidePixel{C,X}) where {C,X} = _length(C) + _length(X)

"""
    color(img::AbstractTIFF{ <: WidePixel}; alpha)

Extract the color channels from multispectral image `img`

The optional `alpha` parameter allows an arbitrary channel to be used as the alpha channel

```jldoctest; setup=:(import TiffImages: DenseTaggedImage, WidePixel; import ColorTypes: RGB, RGBA)
julia> img = DenseTaggedImage(WidePixel.([rand(RGB{Float32}) for x in 1:256, y in 1:256], [(rand(Float32),) for x in 1:256, y in 1:256]));

julia> eltype(img)
WidePixel{RGB{Float32}, Tuple{Float32}}

julia> nchannels(img)
4

julia> eltype(color(img; alpha=4)) # use the fourth channel as an alpha channel
RGBA{Float32}
```
"""
color(img::AbstractTIFF{<:WidePixel}; alpha::Union{Nothing,Integer}=nothing) = color.(img; alpha)

"""
    color(img::AbstractTIFF)

This is an identity relation that just returns `img`
"""
color(img::AbstractTIFF) = img

"""
    color(x::WidePixel; alpha)

Return the value of the `color` field of `x`

The optional `alpha` parameter allows an arbitrary channel to be used as the alpha channel
"""
function color(x::WidePixel{C,X}; alpha::Union{Nothing,Integer}=nothing) where {C,X}
    alpha == nothing ? x.color : ColorTypes.coloralpha(C)(ColorTypes.color(x.color), channel(x, alpha))
end

"""
    color(x::Colorant)

This is an identity relation that just returns `x`
"""
color(x::Colorant) = x

# Adapted from libtiff v4.0.9

#   Copyright (c) 1988-1997 Sam Leffler
#   Copyright (c) 1991-1997 Silicon Graphics, Inc.

#   Permission to use, copy, modify, distribute, and sell this software and
#   its documentation for any purpose is hereby granted without fee, provided
#   that (i) the above copyright notices and this permission notice appear in
#   all copies of the software and related documentation, and (ii) the names of
#   Sam Leffler and Silicon Graphics may not be used in any advertising or
#   publicity relating to the software without the specific, prior written
#   permission of Sam Leffler and Silicon Graphics.

#   THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
#   EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
#   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

#   IN NO EVENT SHALL SAM LEFFLER OR SILICON GRAPHICS BE LIABLE FOR
#   ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
#   OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
#   WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF
#   LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
#   OF THIS SOFTWARE.


#   NB: In the comments below,
#    - items marked with a + are obsoleted by revision 5.0,
#    - items marked with a ! are introduced in revision 6.0.
#    - items marked with a % are introduced post revision 6.0.
#    - items marked with a $ are obsoleted by revision 6.0.
#    - items marked with a & are introduced by Adobe DNG specification.



"""
	$(TYPEDEF)

List of many common named TIFF Tags. This is not an exhaustive list but should
cover most cases.

$(FIELDS)

"""
@enum TiffTag begin
	SUBFILETYPE = 254 			 #  subfile data descriptor
#define	    FILETYPE_REDUCEDIMAGE	0x1	/* reduced resolution version */
#define	    FILETYPE_PAGE		0x2	/* one page of many */
#define	    FILETYPE_MASK		0x4	/* transparency mask */
	OSUBFILETYPE = 255 			 #  +kind of data in subfile
#define	    OFILETYPE_IMAGE		1	/* full resolution image data */
#define	    OFILETYPE_REDUCEDIMAGE	2	/* reduced size image data */
#define	    OFILETYPE_PAGE		3	/* one page of many */
	IMAGEWIDTH = 256 			 #  image width in pixels
	IMAGELENGTH = 257 			 #  image height in pixels
	BITSPERSAMPLE = 258 			 #  bits per channel (sample)
	COMPRESSION = 259 			 #  data compression technique
	PHOTOMETRIC = 262 			 #  photometric interpretation
	THRESHHOLDING = 263 			 #  +thresholding used on data
#define	    THRESHHOLD_BILEVEL		1	/* b&w art scan */
#define	    THRESHHOLD_HALFTONE		2	/* or dithered scan */
#define	    THRESHHOLD_ERRORDIFFUSE	3	/* usually floyd-steinberg */
	CELLWIDTH = 264 			 #  +dithering matrix width
	CELLLENGTH = 265 			 #  +dithering matrix height
	FILLORDER = 266 			 #  data order within a byte
#define	    FILLORDER_MSB2LSB		1	/* most significant -> least */
#define	    FILLORDER_LSB2MSB		2	/* least significant -> most */
	DOCUMENTNAME = 269 			 #  name of doc. image is from
	IMAGEDESCRIPTION = 270 			 #  info about image
	MAKE = 271 			 #  scanner manufacturer name
	MODEL = 272 			 #  scanner model name/number
	STRIPOFFSETS = 273 			 #  offsets to data strips
	ORIENTATION = 274 			 #  +image orientation
#define	    ORIENTATION_TOPLEFT		1	/* row 0 top, col 0 lhs */
#define	    ORIENTATION_TOPRIGHT	2	/* row 0 top, col 0 rhs */
#define	    ORIENTATION_BOTRIGHT	3	/* row 0 bottom, col 0 rhs */
#define	    ORIENTATION_BOTLEFT		4	/* row 0 bottom, col 0 lhs */
#define	    ORIENTATION_LEFTTOP		5	/* row 0 lhs, col 0 top */
#define	    ORIENTATION_RIGHTTOP	6	/* row 0 rhs, col 0 top */
#define	    ORIENTATION_RIGHTBOT	7	/* row 0 rhs, col 0 bottom */
#define	    ORIENTATION_LEFTBOT		8	/* row 0 lhs, col 0 bottom */
	SAMPLESPERPIXEL = 277 			 #  samples per pixel
	ROWSPERSTRIP = 278 			 #  rows per strip of data
	STRIPBYTECOUNTS = 279 			 #  bytes counts for strips
	MINSAMPLEVALUE = 280 			 #  +minimum sample value
	MAXSAMPLEVALUE = 281 			 #  +maximum sample value
	XRESOLUTION = 282 			 #  pixels/resolution in x
	YRESOLUTION = 283 			 #  pixels/resolution in y
	PLANARCONFIG = 284 			 #  storage organization
#define	    PLANARCONFIG_CONTIG		1	/* single image plane */
#define	    PLANARCONFIG_SEPARATE	2	/* separate planes of data */
	PAGENAME = 285 			 #  page name image is from
	XPOSITION = 286 			 #  x page offset of image lhs
	YPOSITION = 287 			 #  y page offset of image lhs
	FREEOFFSETS = 288 			 #  +byte offset to free block
	FREEBYTECOUNTS = 289 			 #  +sizes of free blocks
	GRAYRESPONSEUNIT = 290 			 #  $gray scale curve accuracy
#define	    GRAYRESPONSEUNIT_10S	1	/* tenths of a unit */
#define	    GRAYRESPONSEUNIT_100S	2	/* hundredths of a unit */
#define	    GRAYRESPONSEUNIT_1000S	3	/* thousandths of a unit */
#define	    GRAYRESPONSEUNIT_10000S	4	/* ten-thousandths of a unit */
#define	    GRAYRESPONSEUNIT_100000S	5	/* hundred-thousandths */
	GRAYRESPONSECURVE = 291 			 #  $gray scale response curve
	T4OPTIONS = 292 			 #  TIFF 6.0 proper name alias
#define	    GROUP3OPT_2DENCODING	0x1	/* 2-dimensional coding */
#define	    GROUP3OPT_UNCOMPRESSED	0x2	/* data not compressed */
#define	    GROUP3OPT_FILLBITS		0x4	/* fill to byte boundary */
	T6OPTIONS = 293 			 #  TIFF 6.0 proper name
#define	    GROUP4OPT_UNCOMPRESSED	0x2	/* data not compressed */
	RESOLUTIONUNIT = 296 			 #  units of resolutions
#define	    RESUNIT_NONE		1	/* no meaningful units */
#define	    RESUNIT_INCH		2	/* english */
#define	    RESUNIT_CENTIMETER		3	/* metric */
	PAGENUMBER = 297 			 #  page numbers of multi-page
	COLORRESPONSEUNIT = 300 			 #  $color curve accuracy
#define	    COLORRESPONSEUNIT_10S	1	/* tenths of a unit */
#define	    COLORRESPONSEUNIT_100S	2	/* hundredths of a unit */
#define	    COLORRESPONSEUNIT_1000S	3	/* thousandths of a unit */
#define	    COLORRESPONSEUNIT_10000S	4	/* ten-thousandths of a unit */
#define	    COLORRESPONSEUNIT_100000S	5	/* hundred-thousandths */
	TRANSFERFUNCTION = 301 			 #  !colorimetry info
	SOFTWARE = 305 			 #  name & release
	DATETIME = 306 			 #  creation date and time
	ARTIST = 315 			 #  creator of image
	HOSTCOMPUTER = 316 			 #  machine where created
	PREDICTOR = 317 			 #  prediction scheme w/ LZW
#define     PREDICTOR_NONE		1	/* no prediction scheme used */
#define     PREDICTOR_HORIZONTAL	2	/* horizontal differencing */
#define     PREDICTOR_FLOATINGPOINT	3	/* floating point predictor */
	WHITEPOINT = 318 			 #  image white point
	PRIMARYCHROMATICITIES = 319 			 #  !primary chromaticities
	COLORMAP = 320 			 #  RGB map for palette image
	HALFTONEHINTS = 321 			 #  !highlight+shadow info
	TILEWIDTH = 322 			 #  !tile width in pixels
	TILELENGTH = 323 			 #  !tile height in pixels
	TILEOFFSETS = 324 			 #  !offsets to data tiles
	TILEBYTECOUNTS = 325 			 #  !byte counts for tiles
	BADFAXLINES = 326 			 #  lines w/ wrong pixel count
	CLEANFAXDATA = 327 			 #  regenerated line info
#define	    CLEANFAXDATA_CLEAN		0	/* no errors detected */
#define	    CLEANFAXDATA_REGENERATED	1	/* receiver regenerated lines */
#define	    CLEANFAXDATA_UNCLEAN	2	/* uncorrected errors exist */
	CONSECUTIVEBADFAXLINES = 328 			 #  max consecutive bad lines
	SUBIFD = 330 			 #  subimage descriptors
	INKSET = 332 			 #  !inks in separated image
#define	    INKSET_CMYK			1	/* !cyan-magenta-yellow-black color */
#define	    INKSET_MULTIINK		2	/* !multi-ink or hi-fi color */
	INKNAMES = 333 			 #  !ascii names of inks
	NUMBEROFINKS = 334 			 #  !number of inks
	DOTRANGE = 336 			 #  !0% and 100% dot codes
	TARGETPRINTER = 337 			 #  !separation target
	EXTRASAMPLES = 338 			 #  !info about extra samples
#define	    EXTRASAMPLE_UNSPECIFIED	0	/* !unspecified data */
#define	    EXTRASAMPLE_ASSOCALPHA	1	/* !associated alpha data */
#define	    EXTRASAMPLE_UNASSALPHA	2	/* !unassociated alpha data */
	SAMPLEFORMAT = 339 			 #  !data sample format
#define	    SAMPLEFORMAT_UINT		1	/* !unsigned integer data */
#define	    SAMPLEFORMAT_INT		2	/* !signed integer data */
#define	    SAMPLEFORMAT_IEEEFP		3	/* !IEEE floating point data */
#define	    SAMPLEFORMAT_VOID		4	/* !untyped data */
#define	    SAMPLEFORMAT_COMPLEXINT	5	/* !complex signed int */
#define	    SAMPLEFORMAT_COMPLEXIEEEFP	6	/* !complex ieee floating */
	SMINSAMPLEVALUE = 340 			 #  !variable MinSampleValue
	SMAXSAMPLEVALUE = 341 			 #  !variable MaxSampleValue
    CLIPPATH = 343           # %ClipPath [Adobe TIFF technote 2]
    XCLIPPATHUNITS = 344     # %XClipPathUnits [Adobe TIFF technote 2]
    YCLIPPATHUNITS = 345	 # %YClipPathUnits [Adobe TIFF technote 2]
    INDEXED	= 346        # %Indexed [Adobe TIFF Technote 3]
	JPEGTABLES = 347 			 #  %JPEG table stream
	OPIPROXY = 351 			 #  %OPI Proxy [Adobe TIFF technote]
# Tags 400-435 are from the TIFF/FX spec
	GLOBALPARAMETERSIFD = 400 			 #  !
	PROFILETYPE = 401 			 #  !
#define     PROFILETYPE_UNSPECIFIED	0	/* ! */
#define     PROFILETYPE_G3_FAX		1	/* ! */
	FAXPROFILE = 402 			 #  !
#define     FAXPROFILE_S			1	/* !TIFF/FX FAX profile S */
#define     FAXPROFILE_F			2	/* !TIFF/FX FAX profile F */
#define     FAXPROFILE_J			3	/* !TIFF/FX FAX profile J */
#define     FAXPROFILE_C			4	/* !TIFF/FX FAX profile C */
#define     FAXPROFILE_L			5	/* !TIFF/FX FAX profile L */
#define     FAXPROFILE_M			6	/* !TIFF/FX FAX profile LM */
	CODINGMETHODS = 403 			 #  !TIFF/FX coding methods
#define     CODINGMETHODS_T4_1D		(1 << 1)	/* !T.4 1D */
#define     CODINGMETHODS_T4_2D		(1 << 2)	/* !T.4 2D */
#define     CODINGMETHODS_T6		(1 << 3)	/* !T.6 */
#define     CODINGMETHODS_T85 		(1 << 4)	/* !T.85 JBIG */
#define     CODINGMETHODS_T42 		(1 << 5)	/* !T.42 JPEG */
#define     CODINGMETHODS_T43		(1 << 6)	/* !T.43 colour by layered JBIG */
	VERSIONYEAR = 404 			 #  !TIFF/FX version year
	MODENUMBER = 405 			 #  !TIFF/FX mode number
	DECODE = 433 			 #  !TIFF/FX decode
	IMAGEBASECOLOR = 434 			 #  !TIFF/FX image base colour
	T82OPTIONS = 435 			 #  !TIFF/FX T.82 options

# Tags 512-521 are obsoleted by Technical Note #2 which specifies a
# revised JPEG-in-TIFF scheme.

	JPEGPROC = 512 			 #  !JPEG processing algorithm
#define	    JPEGPROC_BASELINE		1	/* !baseline sequential */
#define	    JPEGPROC_LOSSLESS		14	/* !Huffman coded lossless */
	JPEGIFOFFSET = 513 			 #  !pointer to SOI marker
	JPEGIFBYTECOUNT = 514 			 #  !JFIF stream length
	JPEGRESTARTINTERVAL = 515 			 #  !restart interval length
	JPEGLOSSLESSPREDICTORS = 517 			 #  !lossless proc predictor
	JPEGPOINTTRANSFORM = 518 			 #  !lossless point transform
	JPEGQTABLES = 519 			 #  !Q matrix offsets
	JPEGDCTABLES = 520 			 #  !DCT table offsets
	JPEGACTABLES = 521 			 #  !AC coefficient offsets
	YCBCRCOEFFICIENTS = 529 			 #  !RGB -> YCbCr transform
	YCBCRSUBSAMPLING = 530 			 #  !YCbCr subsampling factors
	YCBCRPOSITIONING = 531 			 #  !subsample positioning
#define	    YCBCRPOSITION_CENTERED	1	/* !as in PostScript Level 2 */
#define	    YCBCRPOSITION_COSITED	2	/* !as in CCIR 601-1 */
	REFERENCEBLACKWHITE = 532 			 #  !colorimetry info
	STRIPROWCOUNTS = 559 			 #  !TIFF/FX strip row counts
	XMLPACKET = 700	         # %XML packet [Adobe XMP Specification, January 2004]
    OPIIMAGEID = 32781	     # %OPI ImageID [Adobe TIFF technote]
# tags 32952-32956 are private tags registered to Island Graphics
	REFPTS = 32953 			 #  image reference points
	REGIONTACKPOINT = 32954 			 #  region-xform tack point
	REGIONWARPCORNERS = 32955 			 #  warp quadrilateral
	REGIONAFFINE = 32956 			 #  affine transformation mat
# tags 32995-32999 are private tags registered to SGI
	MATTEING = 32995 			 #  $use ExtraSamples
	DATATYPE = 32996 			 #  $use SampleFormat
	IMAGEDEPTH = 32997 			 #  z depth of image
	TILEDEPTH = 32998 			 #  z depth/data tile
# tags 33300-33309 are private tags registered to Pixar

# TIFFTAG_PIXAR_IMAGEFULLWIDTH and TIFFTAG_PIXAR_IMAGEFULLLENGTH
# are set when an image has been cropped out of a larger image.
# They reflect the size of the original uncropped image.
# The TIFFTAG_XPOSITION and TIFFTAG_YPOSITION can be used
# to determine the position of the smaller image in the larger one.

    PIXAR_IMAGEFULLWIDTH = 33300     # full image size in x
    PIXAR_IMAGEFULLLENGTH = 33301    # full image size in y

# tag 33405 is a private tag registered to Eastman Kodak
	WRITERSERIALNUMBER = 33405 			 #  device serial number
	CFAREPEATPATTERNDIM = 33421 			 #  dimensions of CFA pattern
	CFAPATTERN = 33422 			 #  color filter array pattern
# tag 33432 is listed in the 6.0 spec w/ unknown ownership
	COPYRIGHT = 33432 			 #  copyright string
# IPTC TAG from RichTIFF specifications
    RICHTIFFIPTC = 33723
# 34016-34029 are reserved for ANSI IT8 TIFF/IT <dkelly@apago.com)
	IT8SITE = 34016 			 #  site name
	IT8COLORSEQUENCE = 34017 			 #  color seq. [RGB,CMYK,etc]
	IT8HEADER = 34018 			 #  DDES Header
	IT8RASTERPADDING = 34019 			 #  raster scanline padding
	IT8BITSPERRUNLENGTH = 34020 			 #  # of bits in short run
	IT8BITSPEREXTENDEDRUNLENGTH = 34021 			 #  # of bits in long run
	IT8COLORTABLE = 34022 			 #  LW colortable
	IT8IMAGECOLORINDICATOR = 34023 			 #  BP/BL image color switch
	IT8BKGCOLORINDICATOR = 34024 			 #  BP/BL bg color switch
	IT8IMAGECOLORVALUE = 34025 			 #  BP/BL image color value
	IT8BKGCOLORVALUE = 34026 			 #  BP/BL bg color value
	IT8PIXELINTENSITYRANGE = 34027 			 #  MP pixel intensity value
	IT8TRANSPARENCYINDICATOR = 34028 			 #  HC transparency switch
	IT8COLORCHARACTERIZATION = 34029 			 #  color character. table
	IT8HCUSAGE = 34030 			 #  HC usage indicator
    IT8TRAPINDICATOR = 34031	 # Trapping indicator (untrapped=0, trapped=1)
	IT8CMYKEQUIVALENT = 34032 			 #  CMYK color equivalents
# tags 34232-34236 are private tags registered to Texas Instruments
	FRAMECOUNT = 34232 			 #  Sequence Frame Count
# tag 34377 is private tag registered to Adobe for PhotoShop
    PHOTOSHOP = 34377
# tags 34665, 34853 and 40965 are documented in EXIF specification
	EXIFIFD = 34665 			 #  Pointer to EXIF private directory
# tag 34750 is a private tag registered to Adobe?
	ICCPROFILE = 34675 			 #  ICC profile data
	IMAGELAYER = 34732 			 #  !TIFF/FX image layer information
# tag 34750 is a private tag registered to Pixel Magic
	JBIGOPTIONS = 34750 			 #  JBIG options
	GPSIFD = 34853 			 #  Pointer to GPS private directory
# tags 34908-34914 are private tags registered to SGI
	FAXRECVPARAMS = 34908 			 #  encoded Class 2 ses. parms
	FAXSUBADDRESS = 34909 			 #  received SubAddr string
	FAXRECVTIME = 34910 			 #  receive time (secs)
	FAXDCS = 34911 			 #  encoded fax ses. params, Table 2/T.30
# tags 37439-37443 are registered to SGI <gregl@sgi.com>
	STONITS = 37439 			 #  Sample value to Nits
# tag 34929 is a private tag registered to FedEx
    FEDEX_EDR = 34929	# unknown use
	INTEROPERABILITYIFD = 40965 			 #  Pointer to Interoperability private directory

	MODELPIXELSCALE = 33550
	MODELTIEPOINT = 33922

	GEOKEYDIRECTORY = 34735
	GEODOUBLEPARAMS = 34736
	GEOASCIIPARAMS = 34737

	GDALMETADATA = 42112
	GDALNODATA = 42113

# Adobe Digital Negative (DNG) format tags */
	DNGVERSION = 50706 			 #  &DNG version number
	DNGBACKWARDVERSION = 50707 			 #  &DNG compatibility version
	UNIQUECAMERAMODEL = 50708 			 #  &name for the camera model
	CFALAYOUT = 50711 			 #  &spatial layout of the CFA
	LINEARIZATIONTABLE = 50712 			 #  &lookup table description
	BLACKLEVEL = 50714 			 #  &zero light encoding level
	DEFAULTSCALE = 50718 			 #  &default scale factors
	CAMERACALIBRATION1 = 50723 			 #  &calibration matrix 1
	CAMERACALIBRATION2 = 50724 			 #  &calibration matrix 2
	BASELINENOISE = 50731 			 #  &relative noise level
	LINEARRESPONSELIMIT = 50734 			 #  &non-linear encoding range
	CAMERASERIALNUMBER = 50735 			 #  &camera's serial number
	LENSINFO = 50736 			 #  info about the lens
	CHROMABLURRADIUS = 50737 			 #  &chroma blur radius
#define TIFFTAG_ANTIALIASSTRENGTH	50738	&relative strength of the camera's anti-alias filter
	SHADOWSCALE = 50739 			 #  &used by Adobe Camera Raw
	DNGPRIVATEDATA = 50740 			 #  &manufacturer's private data
#define TIFFTAG_MAKERNOTESAFETY		50741	whether the EXIF MakerNote tag is safe to preserve along with the rest of the EXIF data
	CALIBRATIONILLUMINANT1 = 50778 			 #  &illuminant 1
	CALIBRATIONILLUMINANT2 = 50779 			 #  &illuminant 2
	BESTQUALITYSCALE = 50780 			 #  &best quality multiplier
#define TIFFTAG_RAWDATAUNIQUEID		50781	/* &unique identifier for
#define TIFFTAG_ORIGINALRAWFILENAME	50827	/* &file name of the original
#define TIFFTAG_ORIGINALRAWFILEDATA	50828	/* &contents of the original
#define TIFFTAG_ACTIVEAREA		50829	/* &active (non-masked) pixels
#define TIFFTAG_MASKEDAREAS		50830	/* &list of coordinates
	ASSHOTICCPROFILE = 50831 			 #  &these two tags used to
#define TIFFTAG_ASSHOTPREPROFILEMATRIX	50832	/* map cameras's color space
	CURRENTICCPROFILE = 50833 			 #  &
	CURRENTPREPROFILEMATRIX = 50834 			 #  &
	IMAGEJ_METADATA_BYTECOUNTS = 50838		# Embedded IMAGEJ metadata
	IMAGEJ_METADATA = 50839
	
# tag 65535 is an undefined tag used by Eastman Kodak
	DCSHUESHIFTVALUES = 65535 			 #  hue shift correction data

# The following are ``pseudo tags'' that can be used to control
# codec-specific functionality.  These tags are not written to file.
# Note that these values start at 0xffff+1 so that they'll never
# collide with Aldus-assigned tags.

# If you want your private pseudo tags ``registered'' (i.e. added to
# this file), please post a bug report via the tracking system at
# http://www.remotesensing.org/libtiff/bugs.html with the appropriate
# C definitions to add.

	FAXMODE = 65536 			 #  Group 3/4 format control
#define	    FAXMODE_CLASSIC	0x0000		/* default, include RTC */
#define	    FAXMODE_NORTC	0x0001		/* no RTC at end of data */
#define	    FAXMODE_NOEOL	0x0002		/* no EOL code at end of row */
#define	    FAXMODE_BYTEALIGN	0x0004		/* byte align row */
#define	    FAXMODE_WORDALIGN	0x0008		/* word align row */
#define	    FAXMODE_CLASSF	FAXMODE_NORTC	/* TIFF Class F */
	JPEGQUALITY = 65537 			 #  Compression quality level
# Note: quality level is on the IJG 0-100 scale.  Default value is 75
	JPEGCOLORMODE = 65538 			 #  Auto RGB<=>YCbCr convert?
#define	    JPEGCOLORMODE_RAW	0x0000		/* no conversion (default) */
#define	    JPEGCOLORMODE_RGB	0x0001		/* do auto conversion */
	JPEGTABLESMODE = 65539 			 #  What to put in JPEGTables
#define	    JPEGTABLESMODE_QUANT 0x0001		/* include quantization tbls */
#define	    JPEGTABLESMODE_HUFF	0x0002		/* include Huffman tbls */
# Note: default is JPEGTABLESMODE_QUANT | JPEGTABLESMODE_HUFF */
	FAXFILLFUNC = 65540 			 #  G3/G4 fill function
	PIXARLOGDATAFMT = 65549 			 #  PixarLogCodec I/O data sz
#define	    PIXARLOGDATAFMT_8BIT	0	/* regular u_char samples */
#define	    PIXARLOGDATAFMT_8BITABGR	1	/* ABGR-order u_chars */
#define	    PIXARLOGDATAFMT_11BITLOG	2	/* 11-bit log-encoded (raw) */
#define	    PIXARLOGDATAFMT_12BITPICIO	3	/* as per PICIO (1.0==2048) */
#define	    PIXARLOGDATAFMT_16BIT	4	/* signed short samples */
#define	    PIXARLOGDATAFMT_FLOAT	5	/* IEEE float samples */
# 65550-65556 are allocated to Oceana Matrix <dev@oceana.com> */
	DCSIMAGERTYPE = 65550 			 #  imager model & filter
#define     DCSIMAGERMODEL_M3           0       /* M3 chip (1280 x 1024) */
#define     DCSIMAGERMODEL_M5           1       /* M5 chip (1536 x 1024) */
#define     DCSIMAGERMODEL_M6           2       /* M6 chip (3072 x 2048) */
#define     DCSIMAGERFILTER_IR          0       /* infrared filter */
#define     DCSIMAGERFILTER_MONO        1       /* monochrome filter */
#define     DCSIMAGERFILTER_CFA         2       /* color filter array */
#define     DCSIMAGERFILTER_OTHER       3       /* other filter */
	DCSINTERPMODE = 65551 			 #  interpolation mode
#define     DCSINTERPMODE_NORMAL        0x0     /* whole image, default */
#define     DCSINTERPMODE_PREVIEW       0x1     /* preview of image (384x256) */
	DCSBALANCEARRAY = 65552 			 #  color balance values
	DCSCORRECTMATRIX = 65553 			 #  color correction values
	DCSGAMMA = 65554 			 #  gamma value
	DCSTOESHOULDERPTS = 65555 			 #  toe & shoulder points
	DCSCALIBRATIONFD = 65556 			 #  calibration file desc
# Note: quality level is on the ZLIB 1-9 scale. Default value is -1
	ZIPQUALITY = 65557 			 #  compression quality level
	PIXARLOGQUALITY = 65558 			 #  PixarLog uses same scale
# 65559 is allocated to Oceana Matrix <dev@oceana.com>
	DCSCLIPRECTANGLE = 65559 			 #  area of image to acquire
	SGILOGDATAFMT = 65560 			 #  SGILog user data format
#define     SGILOGDATAFMT_FLOAT		0	/* IEEE float samples */
#define     SGILOGDATAFMT_16BIT		1	/* 16-bit samples */
#define     SGILOGDATAFMT_RAW		2	/* uninterpreted data */
#define     SGILOGDATAFMT_8BIT		3	/* 8-bit RGB monitor values */
	SGILOGENCODE = 65561 			 #  SGILog data encoding control
#define     SGILOGENCODE_NODITHER	0     /* do not dither encoded values*/
#define     SGILOGENCODE_RANDITHER	1     /* randomly dither encd values */
	LZMAPRESET = 65562 			 #  LZMA2 preset (compression level)
	PERSAMPLE = 65563 			 #  interface for per sample tags
#define     PERSAMPLE_MERGED        0	/* present as a single value */
#define     PERSAMPLE_MULTI         1	/* present as multiple values */


# EXIF tags

	EXIFTAG_EXPOSURETIME = 33434 			 #  Exposure time
	EXIFTAG_FNUMBER = 33437 			 #  F number
	EXIFTAG_EXPOSUREPROGRAM = 34850 			 #  Exposure program
	EXIFTAG_SPECTRALSENSITIVITY = 34852 			 #  Spectral sensitivity
	EXIFTAG_ISOSPEEDRATINGS = 34855 			 #  ISO speed rating
	EXIFTAG_OECF = 34856 			 #  Optoelectric conversion factor
	EXIFTAG_EXIFVERSION = 36864 			 #  Exif version
	EXIFTAG_DATETIMEORIGINAL = 36867 			 #  Date and time of original data generation
	EXIFTAG_DATETIMEDIGITIZED = 36868 			 #  Date and time of digital data generation
	EXIFTAG_COMPONENTSCONFIGURATION = 37121 			 #  Meaning of each component
	EXIFTAG_COMPRESSEDBITSPERPIXEL = 37122 			 #  Image compression mode
	EXIFTAG_SHUTTERSPEEDVALUE = 37377 			 #  Shutter speed
	EXIFTAG_APERTUREVALUE = 37378 			 #  Aperture
	EXIFTAG_BRIGHTNESSVALUE = 37379 			 #  Brightness
	EXIFTAG_EXPOSUREBIASVALUE = 37380 			 #  Exposure bias
	EXIFTAG_MAXAPERTUREVALUE = 37381 			 #  Maximum lens aperture
	EXIFTAG_SUBJECTDISTANCE = 37382 			 #  Subject distance
	EXIFTAG_METERINGMODE = 37383 			 #  Metering mode
	EXIFTAG_LIGHTSOURCE = 37384 			 #  Light source
	EXIFTAG_FLASH = 37385 			 #  Flash
	EXIFTAG_FOCALLENGTH = 37386 			 #  Lens focal length
	EXIFTAG_SUBJECTAREA = 37396 			 #  Subject area
	EXIFTAG_MAKERNOTE = 37500 			 #  Manufacturer notes
	EXIFTAG_USERCOMMENT = 37510 			 #  User comments
	EXIFTAG_SUBSECTIME = 37520 			 #  DateTime subseconds
	EXIFTAG_SUBSECTIMEORIGINAL = 37521 			 #  DateTimeOriginal subseconds
	EXIFTAG_SUBSECTIMEDIGITIZED = 37522 			 #  DateTimeDigitized subseconds
	EXIFTAG_FLASHPIXVERSION = 40960 			 #  Supported Flashpix version
	EXIFTAG_COLORSPACE = 40961 			 #  Color space information
	EXIFTAG_PIXELXDIMENSION = 40962 			 #  Valid image width
	EXIFTAG_PIXELYDIMENSION = 40963 			 #  Valid image height
	EXIFTAG_RELATEDSOUNDFILE = 40964 			 #  Related audio file
	EXIFTAG_FLASHENERGY = 41483 			 #  Flash energy
	EXIFTAG_SPATIALFREQUENCYRESPONSE = 41484 			 #  Spatial frequency response
	EXIFTAG_FOCALPLANEXRESOLUTION = 41486 			 #  Focal plane X resolution
	EXIFTAG_FOCALPLANEYRESOLUTION = 41487 			 #  Focal plane Y resolution
	EXIFTAG_FOCALPLANERESOLUTIONUNIT = 41488 			 #  Focal plane resolution unit
	EXIFTAG_SUBJECTLOCATION = 41492 			 #  Subject location
	EXIFTAG_EXPOSUREINDEX = 41493 			 #  Exposure index
	EXIFTAG_SENSINGMETHOD = 41495 			 #  Sensing method
	EXIFTAG_FILESOURCE = 41728 			 #  File source
	EXIFTAG_SCENETYPE = 41729 			 #  Scene type
	EXIFTAG_CFAPATTERN = 41730 			 #  CFA pattern
	EXIFTAG_CUSTOMRENDERED = 41985 			 #  Custom image processing
	EXIFTAG_EXPOSUREMODE = 41986 			 #  Exposure mode
	EXIFTAG_WHITEBALANCE = 41987 			 #  White balance
	EXIFTAG_DIGITALZOOMRATIO = 41988 			 #  Digital zoom ratio
	EXIFTAG_FOCALLENGTHIN35MMFILM = 41989 			 #  Focal length in 35 mm film
	EXIFTAG_SCENECAPTURETYPE = 41990 			 #  Scene capture type
	EXIFTAG_GAINCONTROL = 41991 			 #  Gain control
	EXIFTAG_CONTRAST = 41992 			 #  Contrast
	EXIFTAG_SATURATION = 41993 			 #  Saturation
	EXIFTAG_SHARPNESS = 41994 			 #  Sharpness
	EXIFTAG_DEVICESETTINGDESCRIPTION = 41995 			 #  Device settings description
	EXIFTAG_SUBJECTDISTANCERANGE = 41996 			 #  Subject distance range
	EXIFTAG_IMAGEUNIQUEID = 42016 			 #  Unique image ID
end

@enum SampleFormats begin
	SAMPLEFORMAT_UINT = 1				# !unsigned integer data
	SAMPLEFORMAT_INT = 2				# !signed integer data
	SAMPLEFORMAT_IEEEFP = 3				# !IEEE floating point data 
	SAMPLEFORMAT_VOID = 4				# !untyped data
	SAMPLEFORMAT_COMPLEXINT = 5			# !complex signed int
	SAMPLEFORMAT_COMPLEXIEEEFP = 6		# !complex ieee floating
end

@enum PhotometricInterpretations begin
	PHOTOMETRIC_MINISWHITE = 0		# min value is white
	PHOTOMETRIC_MINISBLACK = 1		# min value is black
	PHOTOMETRIC_RGB = 2				# RGB color model
	PHOTOMETRIC_PALETTE = 3			# color map indexed
	PHOTOMETRIC_MASK = 4			# $holdout mask
	PHOTOMETRIC_SEPARATED = 5		# !color separations
	PHOTOMETRIC_YCBCR = 6			# !CCIR 601
	PHOTOMETRIC_CIELAB = 8			# !1976 CIE L*a*b*
	PHOTOMETRIC_ICCLAB = 9			# ICC L*a*b* [Adobe TIFF Technote 4]
	PHOTOMETRIC_ITULAB = 10			# ITU L*a*b*
	PHOTOMETRIC_CFA = 32803			# color filter array
	PHOTOMETRIC_LOGL = 32844		# CIE Log2(L)
	PHOTOMETRIC_LOGLUV = 32845		# CIE Log2(L) (u',v')
end

@enum CompressionType begin
	COMPRESSION_NONE = 1			# No compression
	COMPRESSION_CCITTRLE = 2		# CCITT modified Huffman RLE
	COMPRESSION_CCITT_T4 = 3        # CCITT T.4 (TIFF 6 name)
	COMPRESSION_CCITT_T6 = 4 		# CCITT T.6 (TIFF 6 name)
	COMPRESSION_LZW = 5				# Lempel-Ziv  & Welch
	COMPRESSION_OJPEG = 6			# !6.0 JPEG
	COMPRESSION_JPEG = 7			# %JPEG DCT compression
	COMPRESSION_T85	= 9				# !TIFF/FX T.85 JBIG compression
	COMPRESSION_T43 = 10			# !TIFF/FX T.43 colour by layered JBIG compression
	COMPRESSION_NEXT = 32766		# NeXT 2-bit RLE
	COMPRESSION_CCITTRLEW = 32771	#1 w/ word alignment
	COMPRESSION_PACKBITS = 32773	# Macintosh RLE
	COMPRESSION_THUNDERSCAN	= 32809	# ThunderScan RLE
# codes 32895-32898 are reserved for ANSI IT8 TIFF/IT <dkelly@apago.com)
	COMPRESSION_IT8CTPAD = 32895 	# IT8 CT w/padding
	COMPRESSION_IT8LW = 32896   	# IT8 Linework RLE
	COMPRESSION_IT8MP = 32897   	# IT8 Monochrome picture
	COMPRESSION_IT8BL = 32898   	# IT8 Binary line art
# compression codes 32908-32911 are reserved for Pixar
	COMPRESSION_PIXARFILM = 32908   # Pixar companded 10bit LZW
	COMPRESSION_PIXARLOG = 32909   	# Pixar companded 11bit ZIP
	COMPRESSION_DEFLATE = 32946		# Deflate compression
	COMPRESSION_ADOBE_DEFLATE = 8	# Deflate compression, as recognized by Adobe
# compression code 32947 is reserved for Oceana Matrix <dev@oceana.com>
	COMPRESSION_JBIG = 34661		# ISO JBIG
	COMPRESSION_SGILOG = 34676		# SGI Log Luminance RLE
	COMPRESSION_SGILOG24 = 34677	# SGI Log 24-bit packed
	COMPRESSION_JP2000 = 34712   	# Leadtools JPEG2000
	COMPRESSION_LZMA = 34925		# LZMA2
	COMPRESSION_ZSTD = 50000		# ZSTD
end

@enum ExtraSamples begin
	EXTRASAMPLE_UNSPECIFIED = 0			# unspecified data
	EXTRASAMPLE_ASSOCALPHA = 1			# associated alpha data
	EXTRASAMPLE_UNASSALPHA = 2			# unassociated alpha data
	# there's speculation online about this invalid code being used by CorelDraw
	EXTRASAMPLE_ASSOCALPHA_NS = 999		# associated alpha data (non-standard code)
end

# this file must be run manually whenever the set of images for precompilation should be changed
using TiffImages
using ColorTypes
using FixedPointNumbers

types = [N0f8, N0f16, Float32, Float64]
colors = [Gray, RGB]
sizes = [(2, 2), (2, 2, 2)]

images = joinpath(@__DIR__, "images")
rm(images, recursive = true, force = true)
mkdir(images)

# generate tifs to load during precompilation, we can't generate them during precompilation
# because we don't want to spend the time calling `save` there (see issue #180)
files = map(enumerate(Iterators.product(types, colors, sizes))) do (i, (t, c, s))
    file = joinpath(@__DIR__, "images", "$(t)_$(c)_$(s).tif")
    TiffImages.save(file, rand(c{t}, s))
end

import .Iterators.partition

"""
    $(TYPEDEF)

An image file directory is a sorted collection of the tags representing this
plane in the TIFF file. They behave like dictionaries except that tags aren't
required to be unique, so given an IFD called `ifd`, we can add new tags as
follows:

```jldoctest; setup = :(ifd = TiffImages.IFD(UInt32))
julia> ifd[TiffImages.IMAGEDESCRIPTION] = "Some details";

julia> ifd[TiffImages.IMAGEWIDTH] = 512;

julia> ifd
IFD, with tags:
	Tag(IMAGEWIDTH, 512)
	Tag(IMAGEDESCRIPTION, "Some details")
```

!!! note
    Tags are not required to be unique! See [`TiffImages.Iterable`](@ref) for
    how to work with duplicate tags.
"""
struct IFD{O <: Unsigned}
    tags::DefaultDict{UInt16, Vector{Tag}, DataType}
end

IFD(::Type{O}) where {O <: Unsigned} = IFD{O}(DefaultDict{UInt16, Vector{Tag}}(Vector{Tag}))
IFD(::Type{O}, tags) where {O <: Unsigned} = IFD{O}(tags)

"""
A wrapper to force getindex to return the underlying array instead of only the
first element. Usually the first element is sufficient, but sometimes access to
the array is needed (to add duplicate entries or access them).

```jldoctest; setup = :(ifd = TiffImages.IFD(UInt32))
julia> using TiffImages: Iterable

julia> ifd[TiffImages.IMAGEDESCRIPTION] = "test"
"test"

julia> ifd[Iterable(TiffImages.IMAGEDESCRIPTION)] # since wrapped with Iterable, returns array
1-element Vector{TiffImages.Tag}:
 Tag(IMAGEDESCRIPTION, "test")

julia> ifd[Iterable(TiffImages.IMAGEDESCRIPTION)] = "test2" # since wrapped with Iterable, it appends
"test2"

julia> ifd
IFD, with tags:
	Tag(IMAGEDESCRIPTION, "test")
	Tag(IMAGEDESCRIPTION, "test2")

```
"""
struct Iterable{T}
    key::T
end

Base.length(ifd::IFD) = sum(map(length, values(ifd.tags)))
Base.keys(ifd::IFD) = keys(ifd.tags)
Base.values(ifd::IFD) = values(ifd.tags)
Base.iterate(ifd::IFD) = iterate(ifd.tags)
Base.iterate(ifd::IFD, n::Int) = iterate(ifd.tags, n)

Base.getindex(ifd::IFD, key::Iterable{TiffTag}) = getindex(ifd, Iterable(UInt16(key.key)))
Base.getindex(ifd::IFD, key::Iterable{UInt16}) = getindex(ifd.tags, key.key)
Base.getindex(ifd::IFD, key::TiffTag) = getindex(ifd, UInt16(key))
Base.getindex(ifd::IFD, key::UInt16) = first(getindex(ifd.tags, key))

getdata(f::F, ifd::IFD, key::TiffTag, default) where F = getdata(f, ifd, UInt16(key), default)
function getdata(f::F, ifd::IFD, key::UInt16, default) where F
    val = get(ifd.tags, key, nothing)
    val === nothing && return default
    return f(first(val).data)
end
getdata(ifd::IFD, key, default) = getdata(identity, ifd, key, default)

Base.in(key::TiffTag, v::IFD) = in(UInt16(key), v)
Base.in(key::UInt16, v::IFD) = in(key, keys(v))
Base.delete!(ifd::IFD, key::TiffTag) = delete!(ifd, UInt16(key))
Base.delete!(ifd::IFD, key::UInt16) = delete!(ifd.tags, key)

Base.similar(::IFD{O}) where {O <: Unsigned} = IFD(O)
Base.merge(ifd::IFD{O}, other::IFD) where {O <: Unsigned} = IFD(O, DefaultDict(Vector{Int}, merge(ifd.tags, other.tags)))

Base.setindex!(ifd::IFD, value::Tag, key::UInt16) = setindex!(ifd.tags, [value], key)
Base.setindex!(ifd::IFD, value::Tag, key::TiffTag) = setindex!(ifd, value, UInt16(key))

Base.setindex!(ifd::IFD, value, key::TiffTag) = setindex!(ifd, value, UInt16(key))
Base.setindex!(ifd::IFD, value, key::UInt16) = setindex!(ifd, Tag(key, value), key)

Base.setindex!(ifd::IFD, value, key::Iterable{TiffTag}) = setindex!(ifd, value, Iterable(UInt16(key.key)))
Base.setindex!(ifd::IFD, value, key::Iterable{UInt16}) = setindex!(ifd, Tag(key.key, value), key)
Base.setindex!(ifd::IFD, value::Tag, key::Iterable{UInt16}) = push!(ifd.tags[key.key], value)

function isloaded(ifd::IFD)
    for tags in values(ifd.tags)
        for tag in tags
            (!isloaded(tag)) && return false
        end
    end
    true
end

"""
    sizeof(ifd)

Number of bytes that an IFD will use on disk.
"""
function Base.sizeof(ifd::IFD{O}) where {O}
    sz = O == UInt32 ? 2 : sizeof(O)
    for tags in values(ifd)
        for tag in tags
            # tag, data, length, and data
            sz += 2 + 2 + sizeof(O) + sizeof(O)
            if sizeof(tag) > sizeof(O) # if data in tag is larger than slot
                sz += sizeof(tag) # we have add all the additional bytes
            end
        end
    end
    sz += sizeof(O) # slot for subsequent IFD locations
end
"""
    $SIGNATURES

Checks if the data in this IFD is contiguous on disk. Striped data can be read
faster as one contiguous chunk if possible.
"""
function iscontiguous(ifd::IFD)
    if !(ROWSPERSTRIP in ifd) || nrows(ifd) <= ifd[ROWSPERSTRIP].data
        return true
    else
        return all(diff(ifd[STRIPOFFSETS].data) .== ifd[STRIPBYTECOUNTS].data[1:end-1])
    end
end

"""
    $(SIGNATURES)

Updates an [`TiffImages.IFD`](@ref) by replacing all instances of the
placeholder type [`TiffImages.RemoteData`](@ref) with the actual data from the
file `tf`.
"""
function load!(tf::TiffFile, ifd::IFD)
    for key in sort(collect(keys(ifd)))
        tags = ifd[Iterable(key)]
        for (idx, tag) in enumerate(tags)
            tags[idx] = load(tf, tag)
        end
    end
end

function Base.show(io::IO, ifd::IFD)
    print(io, "IFD, with tags: ")
    for key in sort(collect(keys(ifd)))
        tags = ifd[Iterable(key)]
        for tag in tags
            print(io, "\n\t", tag)
        end
    end
end

function Base.read(tf::TiffFile{O}, ::Type{IFD}) where O <: Unsigned
    # Regular TIFF's use 16bits instead of 32 bits for entry data
    N = O == UInt32 ? read(tf, UInt16) : read(tf, O)

    entries = IFD(O)

    for i in 1:N
        tag = read(tf, Tag)
        push!(entries[Iterable(tag.tag)], tag)
    end

    next_ifd = Int(read(tf, O))
    entries, next_ifd
end

function Base.iterate(file::TiffFile{O}) where {O}
    seek(file.io, file.first_offset)
    iterate(file, (read(file, IFD)))
end

"""
    iterate(file, state) -> IFD, Int

Advances the iterator to the next IFD.

**Output**
- `Vector{Int}`: Offsets within file for all strips corresponding to the current
   IFD
- `Int`: Offset of the next IFD
"""
function Base.iterate(file::TiffFile, state::Tuple{Union{<: IFD, Nothing}, Int})
    curr_ifd, next_ifd_offset = state
    # if current element doesn't exist, exit
    (curr_ifd === nothing) && return nothing
    (next_ifd_offset <= 0) && return (curr_ifd, (nothing, 0))

    seek(file.io, next_ifd_offset)
    next_ifd, next_ifd_offset = read(file, IFD)

    return (curr_ifd, (next_ifd, next_ifd_offset))
end

"""
    $(TYPEDEF)

A strip is a contiguous block of separately-encoded image data. A TIFF
file will typically have multiple strips, each decoding to multiple rows of
pixels in the image

$(FIELDS)
"""
struct TiffFileStrip{O}
    """Strip data"""
    io::IOBuffer

    """The IFD corresponding to this strip"""
    ifd::IFD{O}
end

Base.read!(tfs::TiffFileStrip, arr::AbstractArray) = read!(tfs.io, arr)
Base.bytesavailable(tfs::TiffFileStrip) = bytesavailable(tfs.io)

function Base.read!(target::AbstractArray{T, N}, tf::TiffFile{O, S}, ifd::IFD{O}) where {T, N, O, S}
    offsets = TILEOFFSETS in ifd ? ifd[TILEOFFSETS].data : ifd[STRIPOFFSETS].data
    compression = getdata(CompressionType, ifd, COMPRESSION, COMPRESSION_NONE)

    rtype = rawtype(ifd)
    spp = ispalette(ifd) ? 1 : nsamples(ifd)
    rows = nrows(ifd)
    cols = ncols(ifd)
    bps = bitspersample(ifd)
    samples = reinterpret(rtype, target)

    function info()
        compression_name = "?"
        if compression == COMPRESSION_LZW
            compression_name = "LZW"
        elseif compression == COMPRESSION_DEFLATE || compression == COMPRESSION_ADOBE_DEFLATE
            compression_name = "Zip"
        elseif compression == COMPRESSION_PACKBITS
            compression_name = "PackBits"
        end

        cmprssn = compression == COMPRESSION_NONE ? "uncompressed" : "$compression_name-compressed"
        chunks = (istiled(ifd) ? "tile" : "strip") * (length(offsets) == 1 ? "" : "s")
        "reading $(cmprssn), $(isplanar(ifd) ? "planar" : "chunky") image with $(length(offsets)) $(chunks)"
    end

    @debug info()

    # number of input bytes in each strip or tile
    encoded_bytes = TILEBYTECOUNTS in ifd ? ifd[TILEBYTECOUNTS].data : ifd[STRIPBYTECOUNTS].data

    # number of samples (pixels * channels) in each strip or tile
    if istiled(ifd)
        @debug "tile size: $(tilecols(ifd)) x $(tilerows(ifd))"
        # tiled images are always padded to tile boundaries
        strip_samples = map(_ -> tilecols(ifd) * tilerows(ifd) * (isplanar(ifd) ? 1 : spp), encoded_bytes)
    else
        nstrips = length(encoded_bytes)
        rowsperstrip = getdata(Int, ifd, ROWSPERSTRIP, rows)

        if isplanar(ifd)
            # planar files will have separate strips or tiles for each channel
            temp = fill(rowsperstrip * cols, cld(rows, rowsperstrip))
            temp[end] = (rows - (rowsperstrip * (length(temp) - 1))) * cols
            strip_samples = repeat(temp, spp)
        else
            strip_samples = fill(rowsperstrip * cols * spp, nstrips)
            strip_samples[end] = (rows - (rowsperstrip * (nstrips - 1))) * cols * spp
        end

        @assert sum(strip_samples) == rows * cols * spp
    end

    parallel_enabled = something(tryparse(Bool, get(ENV, "JULIA_IMAGES_PARALLEL", "1")), false)
    do_parallel = parallel_enabled && rows * cols > 250_000 # pixels

    comp = Val(compression)
    if is_complicated(ifd)
        tasks::Vector{Task} = []
        start = 1
        for (offset::Int, len::Int, bytes::Int) in zip(offsets, strip_samples, encoded_bytes)
            @debug "reading strip with $len samples from $bytes encoded bytes"

            seek(tf, offset)
            arr = view(samples, start:(start+len-1))
            data = Vector{UInt8}(undef, bytes)
            read!(tf, data)
            tfs = TiffFileStrip{O}(IOBuffer(data), ifd)

            function go(tfs, arr, comp)
                cls = istiled(ifd) ? tilecols(ifd) : cols
                cls = isplanar(ifd) ? cls : cls * spp # number of samples (not pixels) per column
                rws = fld(length(arr), cls)
                sz = uncompressed_size(ifd, cls, rws)
                read!(tfs, view(reinterpret(UInt8, vec(arr)), 1:sz), comp)
                if is_irregular_bps(ifd)
                    arr .= unpack_integers(arr, rws, cls, bps)
                end
                reverse_prediction!(tfs.ifd, arr)
            end

            if do_parallel
                push!(tasks, Threads.@spawn go(tfs, arr, comp))
            else
                go(tfs, arr, comp)
            end

            start += len
        end

        for task in tasks
            wait(task)
        end
    else
        @debug "fast path for uncomplicated images"

        seek(tf, first(offsets))
        read!(tf, target)
    end

    if isplanar(ifd)
        samplesv = vec(samples)
        deplane!(samplesv, spp)
    end
end

function Base.write(tf::TiffFile{O}, ifd::IFD{O}) where {O <: Unsigned}
    if !isloaded(ifd)
        error("Cannot write unloaded IFDs. Use `load!` to populate tags with remote data")
    end

    N = length(ifd)
    O == UInt32 ? write(tf, UInt16(N)) : write(tf, UInt64(N))

    # keep track of which tags are too large to fit in the IFD slot and need a
    # remote location for their data
    remotedata = Vector{Pair{Tag, Vector{Int}}}()
    sorted_keys = sort(collect(keys(ifd)))
    for k in sorted_keys
        tags = ifd[Iterable(k)]
        for tag in tags
            pos = position(tf.io)
            if !write(tf, tag)
                push!(remotedata, tag => [pos])
            end
        end
    end

    # end position, write a zero by default, but this should be updated if any
    # more IFDs are written
    ifd_end_pos = position(tf.io)
    write(tf, O(0))

    for (tag, poses) in remotedata
        tag = tag::Tag
        data_pos = position(tf.io)
        data = tag.data
        # add NUL terminator to the end of Strings that don't have it already
        if eltype(tag) === String
            data = data::SubString{String}
            if !endswith(data, '\0')
                data *= '\0'
            end
            write(tf, data)  # compile-time dispatch
        else
            write(tf, data)  # run-time dispatch
        end
        push!(poses, data_pos)
    end

    for (tag, poses) in remotedata
        tag = tag::Tag
        orig_pos, data_pos = poses
        seek(tf, orig_pos)
        write(tf, tag, data_pos)
    end

    seek(tf, ifd_end_pos)

    return ifd_end_pos
end

# reverse any pre-processing that might have been applied to sample
# values prior to compression
# https://www.awaresystems.be/imaging/tiff/tifftags/predictor.html
function reverse_prediction!(ifd::IFD, arr::AbstractArray{T,N}) where {T, N}
    pred::Int = predictor(ifd)
    # for planar data, each "pixel" in the strip is actually a single channel
    spp::Int = isplanar(ifd) ? 1 : nsamples(ifd)
    columns = istiled(ifd) ? tilecols(ifd) : ncols(ifd)
    rows = istiled(ifd) ? tilerows(ifd) : cld(length(arr), columns * spp)

    GC.@preserve arr begin
        if pred == 2
            @debug "reversing horizontal differencing"

            temp::Ptr{T} = pointer(arr)
            for row in 1:rows
                start = (row - 1) * columns * spp
                for plane in 1:spp
                    previous::T = unsafe_load(temp, start + plane)
                    for i in (spp + plane):spp:(columns - 1) * spp + plane
                        current = unsafe_load(temp, start + i) + previous
                        unsafe_store!(temp, current, start + i)
                        previous = current
                    end
                end
            end
        elseif pred == 3
            @debug "reversing float differencing"

            columns = columns * spp * sizeof(T)

            buffer::Vector{UInt8} = Vector{UInt8}(undef, columns)

            valn = Val(sizeof(T))

            temp2::Ptr{UInt8} = pointer(reinterpret(UInt8, arr))

            for row in 1:rows
                start = (row - 1) * columns
                for plane in 1:spp
                    prev::UInt8 = unsafe_load(temp2, start + plane)
                    for i in (spp + plane):spp:(columns - 1) + plane
                        curr = unsafe_load(temp2, start + i) + prev
                        unsafe_store!(temp2, curr, start + i)
                        prev = curr
                    end
                end
                vw = view(reinterpret(UInt8, arr), start+1:start+columns)
                deplane!(buffer, vw, valn)
            end
        end
    end
end

# {AAA...BBB...CCC...} => {ABCABCABC...}
function deplane!(arr::AbstractVector{T}, n::Integer) where T
    out = Vector{T}(undef, length(arr))
    deplane!(out, arr, Val(n))
end

const is_mac_or_windows_x64 = (Sys.iswindows() || Sys.isapple()) && Sys.ARCH == :x86_64

# {AAA...BBB...CCC...} => {ABCABCABC...}
function deplane!(buffer::AbstractVector{T}, arr::AbstractVector{T}, n::Val{N}) where {T, N}
    @assert length(buffer) == length(arr)
    @assert length(arr) % N == 0

    GC.@preserve arr buffer begin
        if Int(pointer(arr)) & 0x3f > 0 || length(arr) < 64 || is_mac_or_windows_x64
            # small or not 64-byte aligned
            temp = deplane_slow(arr, N)
            GC.@preserve temp begin
                memcpy(pointer(arr), pointer(temp), sizeof(temp))
            end
        else
            deplane_simd!(buffer, arr, n)
            memcpy(pointer(arr), pointer(buffer), sizeof(buffer))
        end
    end
end

# {AAA...BBB...CCC...} => {ABCABCABC...}
function deplane_slow(arr::AbstractVector{T}, n) where T
    @debug "rearranging planar data"
    reshape(arr, fld(length(arr), n), n)'[:]
end

# {AAA...BBB...CCC...} => {ABCABCABC...}
@generated function deplane_simd!(out::Vector{T}, arr::AbstractVector{T}, ::Val{N}) where {T, N}
    width = cld(sizeof(T) * N, 64) * 64
    count = fld(width, sizeof(T) * N) # pixels per iteration

    sym(x) = Symbol("q", x)

    # vload {AAA...}
    # vload {BBB...}
    # ...
    loads = map(x -> :($(sym(x + 1)) = vload(Vec{$count * $(max(1, x)), T}, ptrA + (index + num_pixels * $x - 1) * $(sizeof(T)))), 0:N-1)

    # shuffle1 = {0, X, 1, X+1, ...}
    # shuffle2 = {0, 1, X, 2, 3, X+1, ...}
    # ...
    perms = []
    for k in 1:N-1
        left = count * k # number of elements in the first shuffle vector (see below)
        # take `k` elements from the first vector, followed by one from the second vector, repeated `count` times
        shuffle::Vector{Int} = mapreduce(x -> vcat(x...), vcat, zip(collect.(partition(0:left-1,k)), left:left+count-1))
        push!(perms, :($(Symbol("shuffle", k)) = $(Val(Tuple(shuffle)))))
    end

    # shufflevector {AAA...}, {BBB...}, shuffle1 => {ABABAB...}
    # shufflevector {ABABAB...}, {CCC...}, shuffle2 => {ABCABCABC...}
    # ...
    shuffles::Vector{Expr} = []
    ll, rr = sym(1), 1
    for x in 1:N-1
        input1 = ll
        ll = sym(x + N)
        input2 = sym(rr += 1)
        push!(shuffles, :($ll = shufflevector($input1, $input2, $(Symbol("shuffle", x)))))
    end
    push!(shuffles, :(final = $ll))

    # assignments for each channel in the final loop
    finish = map(x -> :(out[start + i * $N + $x] = arr[iterations * $count + i + num_pixels * $x + 1]), 0:N-1)

    quote
        @debug "rearranging planar data (SIMD)"

        GC.@preserve arr begin
            ptrA = pointer(arr)
            num_pixels = fld(length(arr), N)
            iterations = fld(num_pixels, $count) - 1
            out_index = 1 # output index

            $(perms...)

            @inbounds for index in 1:$count:iterations*$count
                $(loads...)
                $(shuffles...)

                vstore(final, out, out_index)

                out_index += $count * N
            end

            remaining = num_pixels - iterations * $count
            start = iterations * $count * N + 1

            @inbounds for i in 0:remaining-1
                $(finish...)
            end
        end
    end
end

unpack_integers(v::AbstractVector, n::Integer) = unpack_integers(v, 1, length(v), n)

unpack_integers(v::AbstractVector, c::Integer, n::Integer) = unpack_integers(v, fld(length(v), c), c, n)

# unpack `r` rows of `c` n-bit integers to useful word-sized integers
unpack_integers(v::AbstractVector, r, c, n::Integer) = unpack_integers(v, r, c, Val(n))

# for SIMD, must have (c % M) == 0 && (M * N) % (K * 8) == 0, where M is
# the vector width used by the SIMD algorithm; M = 32 doesn't work for
# {27, 29, 31} (K = 8), so we step up to the next power of two
for N in (27, 29, 31)
    @eval unpack_integers(v::AbstractVector, r, c, n::Val{$N}) = c % 64 == 0 ? unpack_integers_simd(v, n) : unpack_integers_slow(v, r, c, $N)
end

unpack_integers(v::AbstractVector, r, c, n::Val{N}) where N = c % 32 == 0 ? unpack_integers_simd(v, n) : unpack_integers_slow(v, r, c, N)

# {AAA, ABB, BBC, CCC} => {AAAA, BBBB, CCCC}
function unpack_integers_slow(v::AbstractVector{T}, rows::Integer, columns::Integer, n::Integer) where T
    @debug "recoding from $n bits per sample"

    vb::Vector{UInt8} = reinterpret(UInt8, vec(v))
    out::Vector{T} = Vector{T}(undef, length(v))
    i = 0 # input index
    j = 0 # output index
    # encoding is done per row, so decoding is also done per row
    for _ in 1:rows
        buffer::UInt64 = 0
        available = 0 # number of valid bits available in buffer
        for _ in 1:columns
            while available < n
                buffer = (buffer << 8) | vb[i+=1]
                available += 8
            end
            val = (buffer >> (available - n)) & ((UInt64(1) << n) - 1)
            out[j+=1] = T(val)
            available -= n
        end
    end
    out
end

# these are "nice" n, for which all packed n-bit integers are encoded within no more
# than sizeof(T) bytes, where T is the smallest integer type big enough to store n bits
const nice_n = filter(x -> !(max(nextpow(2, x), 8) - x in [0,1,2,3,5]), 1:31)

# {AAA, ABB, BBC, CCC} => {AAAA, BBBB, CCCC}
@generated function unpack_integers_simd(A::AbstractVector{T}, n::Val{N}) where {T, N}
    nice = N in nice_n
    TT = nice ? T : widen(T)
    width = max(32, sizeof(TT) * 8) # SIMD vector width
    m = fld(width * N, sizeof(TT) * 8) # input bytes per vector
    count = fld(width, sizeof(TT)) # number of codes per vector

    lp(v::AbstractVector,n) = vcat(zeros(Int, n - length(v)), v)

    function shuffle(N)
        bitrange = 0:m * 8 - 1
        extents = extrema.(partition(bitrange, N))
        Val(Tuple(mapreduce(y -> lp(collect(UnitRange(map(x -> fld.(x, 8), y)...)), sizeof(TT)), vcat, extents)))
    end

    function shift(N)
        len = N * count
        Vec(7 .- last.(extrema.(Iterators.partition(0:len-1,N))) .% 8...)
    end

    mask(N) = Vec(fill(TT(2^N - 1), count)...)

    function main_block(i)
        sym = Symbol
        quote
            $(sym("a", i)) = vload(Vec{$m, UInt8}, in_ptr)
            # arrange bytes so that each TT-sized lane contains a single code (+ extra bits)
            $(sym("b", i)) = shufflevector($(sym("a", i)), shuffle)
            # shift out extra low-order bits
            $(sym("c", i)) = _bswap(reinterpret(Vec{$count, $TT}, $(sym("b", i)))) >> shift
            # mask out extra high-order bits
            $(sym("d", i)) = $(sym("c", i)) & mask
            in_ptr += $m
        end
    end

    function nice_block()
        quote
            $(main_block(1))

            vstore(d1, out_ptr)
            out_ptr += $width
        end
    end

    function non_nice_block()
        quote
            $(main_block(1)) # gives d1
            $(main_block(2)) # gives d2

            # d1 and d2 come from the main_blocks
            t1 = reinterpret(Vec{$count * 2, T}, d1)
            t2 = reinterpret(Vec{$count * 2, T}, d2)

            # shufflevector {AXBXCX...}, {DXEXFX...} => {ABC...DEF...}
            f = shufflevector(t1, t2, shuffle2)

            vstore(f, out_ptr)
            out_ptr += $width
        end
    end

    quote
        @debug "recoding from $N bits per sample (SIMD, $($nice ? "nice" : "not nice"))"

        # decoded integers per iteration
        num = fld($width, sizeof(T))

        @assert length(A) % num == 0

        out = Vector{T}(undef, length(A))
        GC.@preserve A out begin
            in_ptr::Ptr{UInt8} = reinterpret(Ptr{UInt8}, pointer(A))
            out_ptr::Ptr{T} = pointer(out)

            shuffle = $(shuffle(N))
            shift = $(shift(N))
            mask = $(mask(N))

            shuffle2 = $(Val(Tuple(0:2:count*4-1)))

            iterations = fld(length(A), num)
            for i in 1:iterations
                $(nice ? nice_block() : non_nice_block())
            end

            out
        end
    end
end

"""
    $(TYPEDEF) -> TiffFile

Wrap `io` with helper parameters to keep track of file attributes.

$(FIELDS)
"""
mutable struct TiffFile{O <: Unsigned, S <: Stream}
    """A unique identifier for this file"""
    uuid::Union{UUID, Nothing}

    """The relative path to this file"""
    filepath::String

    """The file stream"""
    io::S

    """Location of the first IFD in the file stream"""
    first_offset::Int

    """Whether this file has a different endianness than the host computer"""
    need_bswap::Bool
end

TiffFile{O}(s::Stream) where O <: Unsigned = TiffFile{O, typeof(s)}(nothing, "", s, -1, false)
TiffFile{O}(io::IO) where O <: Unsigned    = TiffFile{O}(getstream(format"TIFF", io))
TiffFile{O}() where O <: Unsigned          = TiffFile{O}(IOBuffer())

function Base.read(io::Stream, ::Type{TiffFile})
    seekstart(io)
    filepath = String(extract_filename(io))::String
    bs = need_bswap(io)
    offset_size = offsetsize(io)
    first_offset_raw = read(io, offset_size)
    first_offset = Int(bs ? _bswap(first_offset_raw) : first_offset_raw)
    TiffFile{offset_size, typeof(io)}(nothing, filepath, io, first_offset, bs)
end

Base.read(io::IOStream, t::Type{TiffFile}) = read(getstream(format"TIFF", io, extract_filename(io)), t)

"""
    sizeof(file)

Number of bytes that `file`'s header will use on disk
"""
Base.sizeof(file::TiffFile{UInt32}) = 8
Base.sizeof(file::TiffFile{UInt64}) = 16

function Base.write(file::TiffFile{O}) where O
    seekstart(file.io)

    if ENDIAN_BOM == 0x04030201 #little endian
        write(file.io, "II")
    else
        write(file.io, "MM")
    end

    ifd_pos = 4 # position where the offset info is
    if O == UInt32
        write(file.io, UInt16(42)) # regular tiff
        write(file.io, UInt32(8)) # first offset is right after header
    elseif O == UInt64
        write(file.io, UInt16(43)) # big tiff
        write(file.io, UInt16(8)) # byte size of offsets
        write(file.io, UInt16(0)) # constant
        ifd_pos = position(file.io)
        write(file.io, UInt64(16)) # first offset is right after header
    else
        error("Unknown offset size")
    end
    ifd_pos
end


"""
    offset(file)

Returns the type of the TIFF file offset. For most TIFFs, it should be UInt32,
while for BigTIFFs it will be UInt64.
"""
offset(file::TiffFile{O}) where {O} = O

function Base.read(file::TiffFile{O}, ::Type{T}) where {O, T}
    value = read(file.io, T)
    file.need_bswap ? _bswap(value) : value
end

function Base.read(file::TiffFile{O}, ::Type{String}) where O
    value = read(file.io, O)
    file.need_bswap ? _bswap(value) : value
end

function Base.read!(file::TiffFile, arr::AbstractArray)
    read!(stream(file.io), arr)
end

Base.write(file::TiffFile, t) = write(file.io.io, t)::Int
Base.write(file::TiffFile, arr::AbstractVector{Any}) = write(file.io.io, Array{UInt8}(arr))::Int

Base.seek(file::TiffFile, n::Integer) = seek(file.io, n)
FileIO.stream(file::TiffFile) = stream(file.io)

_bswap(x::Rational{T}) where {T} = Rational(_bswap(x.num), _bswap(x.den))

Base.IteratorSize(::TiffFile) = Base.SizeUnknown()
Base.eltype(::TiffFile{O}) where {O} = IFD{O}

import .Iterators.drop

istiled(ifd::IFD) = TILEWIDTH in ifd
isplanar(ifd::IFD) = Int(getdata(ifd, PLANARCONFIG, 1)) == 2
tilecols(ifd::IFD) = Int(ifd[TILEWIDTH].data)::Int
tilerows(ifd::IFD) = Int(ifd[TILELENGTH].data)::Int
nrows(ifd::IFD) = Int(ifd[IMAGELENGTH].data)::Int
ncols(ifd::IFD) = Int(ifd[IMAGEWIDTH].data)::Int
nsamples(ifd::IFD) = Int(getdata(ifd, SAMPLESPERPIXEL, 1))
predictor(ifd::IFD) = Int(getdata(ifd, PREDICTOR, 0))
bitspersample(ifd::IFD) = Int(first(ifd[BITSPERSAMPLE].data))::Int
ispalette(ifd::IFD) = Int(getdata(ifd, PHOTOMETRIC, 0)) == 3
compression(ifd::IFD) = getdata(CompressionType, ifd, COMPRESSION, COMPRESSION_NONE)
colortype(ifd::IFD) = interpretation(ifd)

is_irregular_bps(ifd::IFD) = bitspersample(ifd) != sizeof(rawtype(ifd)) * 8
is_complicated(ifd::IFD) = !iscontiguous(ifd) || compression(ifd) != COMPRESSION_NONE || is_irregular_bps(ifd) == true || predictor(ifd) > 1

# returns true if all slices have the same size and color type
function is_homogeneous(ifds::Vector{<:IFD})
    return all(map(==(nrows(first(ifds))), nrows.(ifds))) &&
        all(map(==(ncols(first(ifds))), ncols.(ifds))) &&
        all(map(==(colortype(first(ifds))), colortype.(ifds))) &&
        # tiled images are padded during encoding, so 'nrows' and 'ncols'
        # may not indicate the true space requirements for decoding
        all(map(==(istiled(first(ifds))), istiled.(ifds)))
end

"""
    interpretation(ifd)

For a given IFD, determine the proper colorimetric interpretation of the data.
It returns subtypes of `ColorOrTuple` depending on the values of the tiff tags and
whether there are extrasamples it doesn't know how to deal with.
"""
function interpretation(ifd::IFD)
    interp = PhotometricInterpretations(ifd[PHOTOMETRIC].data)
    bps = Int.(ifd[BITSPERSAMPLE].data)
    extras = EXTRASAMPLES in ifd ? ExtraSamples(first(ifd[EXTRASAMPLES].data)) : missing
    type = interpretation(interp, extras)

    if length(type) == nsamples(ifd)
        return type{_mappedtype(rawtype(ifd), first(bps))}
    else
        sf = SampleFormats.(SAMPLEFORMAT in ifd ? Int.(ifd[SAMPLEFORMAT].data) : fill(1, length(bps)))

        # color type, eg RGB{N0f8}
        ctype = type{_mappedtype(rawtype(ifd), first(bps))}

        # number of components, eg 3 for RGB
        n = length(ctype)

        # tuple type for "extra" channels, dervied from "sample format" and "bits per sample" tags
        extratype = Tuple{_mappedtype.(rawtype.(drop(sf, n), drop(bps, n)), drop(bps, n))...}

        WidePixel{ctype, extratype}
    end
end

interpretation(p::PhotometricInterpretations, x::Union{Missing, ExtraSamples}) = interpretation(Val(p), Val(x))
interpretation(::Val{PHOTOMETRIC_RGB}) = RGB
interpretation(::Val{PHOTOMETRIC_MINISBLACK}) = Gray
interpretation(::Val{PHOTOMETRIC_PALETTE}) = Palette
interpretation(::Val{PHOTOMETRIC_YCBCR}) = YCbCr
interpretation(::Val{PHOTOMETRIC_CIELAB}) = Lab
interpretation(p::Val, ::Val) = interpretation(p)
interpretation(p::Val, ::Val{EXTRASAMPLE_UNASSALPHA}) = interpretation(p)
interpretation(p::Val, ::Val{EXTRASAMPLE_ASSOCALPHA}) = coloralpha(interpretation(p))
interpretation(p::Val, ::Val{EXTRASAMPLE_ASSOCALPHA_NS}) = coloralpha(interpretation(p))

# dummy color type for palette colored images to dispatch on
struct Palette{T} <: Colorant{T, 1}
    i::T
end

Base.adjoint(x::WidePixel) = x

_mappedtype(::Type{T}, bps) where {T} = T
_mappedtype(::Type{T}, bps) where {T <: Unsigned} = Normed{T, bps}
_mappedtype(::Type{T}, bps) where {T <: Signed}   = Fixed{T, bps - 1}

function rawtype(format::SampleFormats, bits::Int)
    bits < 1 || bits > 64 && error("unsupported bit depth ($bits)")

    if format == SAMPLEFORMAT_IEEEFP
        if bits == 16
            rtype = Float16
        elseif bits == 32
            rtype = Float32
        elseif bits == 64
            rtype = Float64
        else
            error("unsupported sample format")
        end
    elseif format == SAMPLEFORMAT_UINT || format == SAMPLEFORMAT_INT
        m = trailing_zeros(nextpow(2, bits))
        if m <= 3
            rtype = format == SAMPLEFORMAT_UINT ? UInt8 : Int8
        elseif m == 4
            rtype = format == SAMPLEFORMAT_UINT ? UInt16 : Int16
        elseif m == 5
            rtype = format == SAMPLEFORMAT_UINT ? UInt32 : Int32
        elseif m == 6
            rtype = format == SAMPLEFORMAT_UINT ? UInt64 : Int64
        else
            error("unsupported sample format")
        end
    else
        error("unsupported sample format")
    end

    @debug "raw type for ($format, $bits) is $rtype"

    rtype
end

function rawtype(ifd::IFD)
    samplesperpixel = nsamples(ifd)
    bps = bitspersample(ifd)
    sampleformats = fill(UInt16(0x01), samplesperpixel)
    if SAMPLEFORMAT in ifd
        sampleformats = ifd[SAMPLEFORMAT].data
    end

    format = SampleFormats(first(sampleformats))
    n = first(bps)

    rawtype(format, n)
end

"""
    $(SIGNATURES)

Allocate a cache for this IFD with correct type and size.
"""
function getcache(ifd::IFD)
    pixeltype = interpretation(ifd)
    if istiled(ifd)
        tile_width = tilecols(ifd)
        tile_height = tilerows(ifd)
        return Array{pixeltype}(undef, cld(ncols(ifd), tile_width) * tile_width, cld(nrows(ifd), tile_height) * tile_height)
    else
        return Array{pixeltype}(undef, ncols(ifd), nrows(ifd))
    end
end

function uncompressed_size(ifd::IFD, columns::Int, rows::Int)
    bps = bitspersample(ifd)
    # each row is encoded separately
    cld(columns * bps, 8) * rows
end

"""
    read!(io, arr, comp)

Read in an array `arr` from the [`TiffFile`](@ref) or [`TiffFileStrip`](@ref)
stream `io`, inflating the data using compression method `comp`. `read!` will
dispatch on the value of compression and use the correct compression technique
to read the data.
"""
Base.read!(tfs::Union{TiffFile, TiffFileStrip}, arr::AbstractVector{UInt8}, comp::CompressionType) = read!(tfs.io, arr, Val(comp))

Base.read!(tfs::Union{TiffFile, TiffFileStrip}, arr::AbstractVector{UInt8}, ::Val{COMPRESSION_NONE}) = read!(tfs.io, arr)

function Base.read!(tfs::TiffFileStrip, arr::AbstractVector{UInt8}, ::Val{COMPRESSION_PACKBITS})
    len = length(arr)

    pos = 1
    nbit = Array{Int8}(undef, 1)
    nxt = Array{UInt8}(undef, 1)
    while pos < len
        read!(tfs.io, nbit)
        n = nbit[1]
        if 0 <= n <= 127
            read!(tfs.io, view(arr, pos:pos+n))
            pos += n
        elseif -127 <= n <= -1
            read!(tfs.io, nxt)
            arr[pos:(pos-n)] .= nxt[1]
            pos += -n
        end
        pos += 1
    end
end

function Base.read!(tfs::TiffFileStrip, arr::AbstractVector{UInt8}, ::Val{COMPRESSION_DEFLATE})
    readbytes!(InflateZlibStream(tfs.io), arr)
end

function Base.read!(tfs::TiffFileStrip, arr::AbstractVector{UInt8}, ::Val{COMPRESSION_ADOBE_DEFLATE})
    readbytes!(InflateZlibStream(tfs.io), arr)
end

function lzw_decode!(io, arr)
    CLEAR_CODE::Int = 256 + 1
    EOI_CODE::Int = 257 + 1
    TABLE_ENTRY_LENGTH_BITS::Int = 16
    TABLE_ENTRY_OFFSET_BITS::Int = 8 * sizeof(Int) - TABLE_ENTRY_LENGTH_BITS

    output_size = length(arr)

    GC.@preserve arr begin
        out_pointer::Ptr{UInt8} = pointer(arr)
        out_position::Int = 0 # current position in out

        table_size::Int = output_size * 2 + 258
        table_pointer::Ptr{UInt8} = reinterpret(Ptr{UInt8}, Libc.malloc(table_size)) # table of strings
        table_offsets_pointer::Ptr{Int} = reinterpret(Ptr{Int}, Libc.malloc(sizeof(Int) * 4097)) # offsets into table

        @inline create_table_entry(length, offset) = Base.shl_int(length, TABLE_ENTRY_OFFSET_BITS) | offset
        @inline table_entry_length(table_entry) = Base.lshr_int(table_entry, TABLE_ENTRY_OFFSET_BITS)
        @inline table_entry_offset(table_entry) = table_entry & (Base.shl_int(1, TABLE_ENTRY_OFFSET_BITS) - 1)

        try
            # InitializeTable();
            foreach(i -> unsafe_store!(table_pointer + i, UInt8(i)), 0:255)
            foreach(i -> unsafe_store!(table_offsets_pointer, create_table_entry(1, i), i+1), 0:259) # length is stored in upper 16 bits

            code = -1

            buffer::Int=0 # buffer for reading in codes
            bitcount::Int=0 # number of valid bits in buffer
            codesize::Int=9 # current number of bits per code
            input::Vector{UInt8} = Vector{UInt8}(undef, bytesavailable(io))
            read!(io, input)
            function getcode(buffer, code, bitcount, codesize, i)
                old_code::Int = code

                # make sure we have enough bits in the buffer
                if bitcount < codesize
                    buffer = Base.shl_int(buffer, 8) | input[i+=1]
                    bitcount += 8
                end

                # one more time (since the max code size is 12 bits, only need to check twice)
                if bitcount < codesize
                    buffer = Base.shl_int(buffer, 8) | input[i+=1]
                    bitcount += 8
                end

                code = Base.lshr_int(buffer, bitcount - codesize) & (Base.shl_int(1, codesize) - 1)
                bitcount -= codesize
                # code + 1 because this is Julia
                (buffer, code + 1, old_code, bitcount, codesize, i)
            end

            @inline check_table_overflow(start, length) = start + length > table_size && error("LZW: table buffer overflow")
            @inline check_output_overflow(start, length) = start + length > output_size && error("LZW: output buffer overflow")

            # annotated with excerpts from the LZW pseudocode in the TIFF 6.0 spec
            # https://developer.adobe.com/content/dam/udp/en/open/standards/tiff/TIFF6.pdf
            table_count::Int = 258 # number of (valid) table entries; 256 one-byte codes + CLEAR_CODE + EOI_CODE
            next_table_offset::Int = 258
            input_pos::Int = 0 # current position in input
            while true
                # GetNextCode()
                (buffer, code, old_code, bitcount, codesize, input_pos) = getcode(buffer, code, bitcount, codesize, input_pos)
                if code == EOI_CODE || out_position >= output_size
                    break
                elseif code == CLEAR_CODE # reset table
                    # InitializeTable();
                    table_count = 258
                    next_table_offset = 258
                    codesize = 9
                    # Code = GetNextCode();
                    (buffer, code, old_code, bitcount, codesize, input_pos) = getcode(buffer, code, bitcount, codesize, input_pos)
                    if code == EOI_CODE
                        break
                    end
                    # WriteString(StringFromCode(Code))
                    r = unsafe_load(table_offsets_pointer, code)
                    len = table_entry_length(r)

                    check_output_overflow(out_position, len)

                    memcpy(out_pointer + out_position, table_pointer + table_entry_offset(r), len)
                    out_position += len
                else
                    if code <= table_count
                        # WriteString(StringFromCode(Code));
                        if code <= 256
                            # this is redundant with the check above, but it makes
                            # the code easier to reason about and less bug prone
                            check_output_overflow(out_position, 1)

                            unsafe_store!(out_pointer + out_position, code - 1)
                            out_position += 1
                        else
                            r = unsafe_load(table_offsets_pointer, code)
                            len = table_entry_length(r)

                            check_output_overflow(out_position, len)

                            memcpy(out_pointer + out_position, table_pointer + table_entry_offset(r), len)
                            out_position += len
                        end

                        # AddStringToTable(StringFromCode(OldCode) + FirstChar(StringFromCode(Code)));
                        table_count += 1
                        len = 1
                        if old_code <= 256
                            check_table_overflow(next_table_offset, 2) # this byte + the next one

                            unsafe_store!(table_pointer + next_table_offset, UInt8(old_code - 1))
                        else
                            r = unsafe_load(table_offsets_pointer, old_code)
                            len = table_entry_length(r)

                            check_table_overflow(next_table_offset, len + 1) # these bytes + the next one

                            memcpy(table_pointer + next_table_offset, table_pointer + table_entry_offset(r), len)
                        end

                        if code <= 256
                            unsafe_store!(table_pointer + next_table_offset + len, UInt8(code - 1))
                        else
                            r = unsafe_load(table_offsets_pointer, code)
                            memcpy(table_pointer + next_table_offset + len, table_pointer + table_entry_offset(r), 1)
                        end
                        unsafe_store!(table_offsets_pointer, create_table_entry(len + 1, next_table_offset), table_count)
                        next_table_offset += len + 1
                    else
                        # WriteString(StringFromCode(OldCode) + FirstChar(StringFromCode(OldCode)));
                        r = unsafe_load(table_offsets_pointer, old_code)
                        len = table_entry_length(r)

                        check_output_overflow(out_position, len + 1)

                        memcpy(out_pointer + out_position, table_pointer + table_entry_offset(r), len)
                        unsafe_store!(out_pointer + out_position + len, unsafe_load(table_pointer + table_entry_offset(r)))
                        out_position += len + 1

                        check_table_overflow(next_table_offset, len + 1)

                        # AddStringToTable(StringFromCode(OldCode) + FirstChar(StringFromCode(OldCode)));
                        table_count += 1
                        memcpy(table_pointer + next_table_offset, table_pointer + table_entry_offset(r), len)
                        memcpy(table_pointer + next_table_offset + len, table_pointer + table_entry_offset(r), 1)
                        unsafe_store!(table_offsets_pointer, create_table_entry(len + 1, next_table_offset), table_count)
                        next_table_offset += len + 1
                    end
                end

                if out_position < output_size
                    if table_count == 511
                        codesize = 10
                    elseif table_count == 1023
                        codesize = 11
                    elseif table_count == 2047
                        codesize = 12
                    end
                end
            end

            out_position != output_size && @warn "LZW: expected $output_size bytes, got $out_position bytes"
            out_position == output_size && code != EOI_CODE && @warn "LZW: missing EOI code"
        catch e
            error("LZW: $e")
            rethrow()
        finally
            Libc.free(table_pointer)
            Libc.free(table_offsets_pointer)
        end
    end
end

function Base.read!(tfs::TiffFileStrip{S}, arr::AbstractVector{UInt8}, ::Val{COMPRESSION_LZW}) where S
    lzw_decode!(tfs, arr)
end

function Base.read!(::Union{TiffFile, TiffFileStrip}, ::AbstractVector{UInt8}, ::Val{C}) where C
    error("Compression $C is not implemented. Please open an issue against TiffImages.jl.")
end

# # Lazy TIFFs

# If you're running into memory-limitations when working with large datasets,
# you can lazy-load or memory-map the file so that it looks and behaves as if it were loaded,
# but actually loads data only when needed.

#md # ```@contents
#md # Pages = ["mmap_lazyio.md"]
#md # Depth = 5
#md # ```

get_example(name) = download("https://github.com/tlnagy/exampletiffs/blob/master/$name?raw=true") #hide
filepath = get_example("mri.tif");                                                                #hide

# ### Memory-mapping and lazy loading

# Loading lazily is very similar to [Reading TIFFs](@ref), except with the addition of
# the `mmap=true` *or* `lazyio=true` flag. The differences between the two will be
# described in the next section. 
# !!! tip
#     A good general rule is to preferentially use `mmap=true`. It will generally be
#     faster and, perhaps even more importantly, will have much better worst-case 
#     behavior. However, it's more limited in the types of TIFFs that are supported, 
#     e.g. compressed and/or striped TIFFs are not supported. For those files, use
#     `lazyio=true`, which is more flexible.
#     
#     See the [Caveats and important details](@ref) section for more details.
#    

# First, let's look at a demonstration using `mri.tif` from the
# [`tlnagy/exampletiffs`](https://github.com/tlnagy/exampletiffs) repo.

using TiffImages
img = TiffImages.load(filepath; lazyio=true);

# Regardless of the size of the file, this is likely to return `img`
# almost immediately. The trick is that the data are not actually loaded (yet)--
# the image data will be loaded on an as-needed basis.

# The lazily-loaded img will behave much the same as a normal eagerly-loaded
# image:

size(img)

# Display the 2nd slice

img[:, :, 2]


# #### Lazy operations

# One of the primary benefits of lazy-loading is avoiding unnecessary work for
# portions of the image that may never be accessed.
# I recommend using `MappedArrays` to continue the "laziness" of operations.

using Colors
using MappedArrays

eltype(img)

# We can lazily modify our data for only the slices we end up actually
# displaying. For example, `img` is stored as an RGB, despite the fact
# that you can see it consists only of grayscale intensities.
# Let's convert the `eltype` lazily:

gray_img = of_eltype(Gray, img);

# Then when we extract a slice from disk, it converts only that one to gray

slice = gray_img[:, :, 1]

# We can check to make sure its `eltype` is correct:

eltype(slice)

# #### Example: Maximum intensity projection

# It's pretty straigtforward to do a max-intensity projection:

dropdims(maximum(gray_img, dims=3), dims=3)

# While this demonstration was performed with `lazyio=true`, for files that
# support `mmap=true` the results would be similar.

# ### Caveats and important details

# #### Mechanism, format support, and performance

# `mmap=true` and `lazyio=true` correspond, internally, to two different strategies
# for deferring the work of loading, and the differences can be visible to users.

# - `lazyio=true` uses an internal single-slice data buffer, and each frame of the TIFF
#   file is read into this buffer on an as-needed basis.
# - `mmap=true` uses [memory-mapped I/O](https://en.wikipedia.org/wiki/Memory-mapped_I/O)
#   to set up a virtual address space for the entire array, and the operating system's
#   memory manager takes care of loading chunks of data into physical memory and
#   mapping it to the virtual address space on an as-needed basis.

# The two strategies support different features and exhibit different performance:
#
# - `mmap=true` requires a one-to-one correspondence between what is on disk and what
#   is in memory. Consequently, features like compression are not supported.
#   Currently, there is also no support for files that write slice data in
#   [strips](https://en.wikipedia.org/wiki/TIFF#Overview). Both of these features
#   are supported with `lazyio=true`.
# - with `lazyio=true`, switching slices is an expensive operation, because an entire
#   new slice has to be read into the buffer; as a consequence, access patterns that
#   stay "within-slice" (like `sum(img[:,:,1])`) are fast, while access patterns that
#   cross slices (like `sum(img[1, 1, :])`) are slow; access patterns that alternate
#   between slices (e.g., interpolation across the third dimension) are essentially unusable.
#   `mmap=true` can be more selective about the data it loads, for example reading subsets
#   of single slices. It can also keep previously-loaded data in memory even as you switch
#   slice planes, so that reloads are less common. Consequently, when supported,
#   `mmap=true` achieves good performance more consistently.

# #### Assigning values and writing to disk

# Aside from generality and performance, there are other important differences.
# Currently, `lazyio=true` does not support assigning new values to the array:
# `img[:, :, 2] .= 0.0` throws an error. `mmap=true` can support setting values,
# but *setting values also writes those same values to the disk file*. To guard against
# unintended data corruption, by default `load(filepath; mmap=true)` opens the file with
# read-only permission, and then assigning values throws an error. Using `flagler.tif` from the
# [`tlnagy/exampletiffs`](https://github.com/tlnagy/exampletiffs) repo
# (a file which is of a format that can be read with `mmap=true`), we get

filepath_flagler = get_example("flagler.tif");                                                                #hide
img = TiffImages.load(filepath_flagler, mmap=true)

# but

# ```julia
# julia> img[1,1,1] = RGB(1, 0, 0)
# ERROR: ReadOnlyMemoryError()
# ```

# To support writing, open the file with read/write permissions:

img = TiffImages.load(filepath_flagler, mode="r+", mmap=true);

# Then, assignment will work and *the same value will be written to the disk file*.

# !!! warning
#     Casual use of `mode="r+"` can lead to data corruption, so use it only when
#     you intend to rewrite data.

# #### Behavior on Windows

# On Microsoft Windows, one additional caveat is that deleting or replacing a file
# that has been `mmap`ed by your Julia process will result in either a
# `IOError: unlink(<file path>): permission denied (EACCES)` or
# `LoadError: SystemError: opening file <file path>: Invalid argument`
# error. If you're done using the image, you may want to ensure it is
# garbage-collected first:

img = nothing
GC.gc()

# If successful, this will terminate the `mmap` and the file can be deleted
# without causing an error in the Julia session. However, any reference to
# `img` by any other object can prevent garbage collection; one safe pattern
# is

# ```julia
# let img = TiffImages.load(filepath; mmap=true)
#     # operations on `img` go here
# end
# GC.gc()
# ```

# Such tricks are not generally necessary on other platforms, which handle
# deletion by unlinking the file from its name but otherwise keep the data on disk
# if it is being `mmap`ped by one or more processes. After all such processes have
# exited, the actual data are deleted by the operating system.

# ### Incremental writing

# `TiffImages` also supports writing to a file via an append
# operation. We have a special type for this called 
# [`LazyBufferedTIFF`](@ref), that we can create via the standard
# `empty` function

using TiffImages #hide
#--------------
using ImageCore # reexports Gray and N0f8
img2 = empty(LazyBufferedTIFF, Gray{N0f8}, "test.tif")

# !!! note
#     For data-integrity reasons, `TiffImages` will not allow you to append to
#     an pre-existing file and will throw an error if a file exists at the
#     filepath that you provide.

# Say you have the following data:

slice = rand(Gray{N0f8}, 256, 256)

# You can then push new data to the `img2` object and it will eagerly write that
# data to disk.

push!(img2, slice)

# The first slice sets the XY dimensions of the TIFF and subsequent slices must
# have the same dimensions as the first.

push!(img2, rand(Gray{N0f8}, 256, 256))

# The memory-mapped object also behaves like an array and supports most array
# operations (other than inplace mutating ones like `setindex!`)

size(img2)

# To read a slice that you just wrote:

img2[:, :, 2]

# #### XL files

# If you're going to be writing lots of data to disk (4GB+) then it can be
# helpful to set the `bigtiff` flag to true so that `TiffImages` can use 64-bit
# offsets. You'll see that the addressable space sky rockets:

img3 = empty(LazyBufferedTIFF, Gray{N0f16}, "test.btif"; bigtiff=true)

"""
    $(TYPEDEF)

A type to represent lazily-loaded TIFF data, returned by `TiffImages.load(filepath; lazyio=true)`.
Useful for opening and operating on images too large to store in memory,
and for incrementally writing new TIFF files.

This works by buffering individual slices. This allows broad format support, including compressed
TIFFs, but with mixed performance depending on your specific access (indexing) patterns.
See discussion in the package documentation, and [`MmappedTIFF`](@ref) for an alternative
with different strengths and weaknesses.

```jldoctest
julia> using TiffImages, ColorTypes

julia> img = empty(LazyBufferedTIFF, Gray{Float32}, joinpath(mktempdir(), "test.tif"))
32-bit LazyBufferedTIFF{Gray{Float32}} 0×0×0 (writable)
    Current file size on disk:   8 bytes
    Addressable space remaining: 4.000 GiB

julia> close(img) # when you're done, close the stream
```

$(FIELDS)
"""
mutable struct LazyBufferedTIFF{T <: ColorOrTuple, O <: Unsigned, AA <: AbstractArray} <: AbstractDenseTIFF{T, 3}

    """
    Pointer to keep track of the backing file
    """
    file::TiffFile{O}
    """
    The associated tags for each slice in this array
    """
    ifds::Vector{IFD{O}}

    dims::NTuple{3, Int}

    """
    An internal cache to fill reading from disk
    """
    working_cache::AA

    """
    An internal cache to fill with fully transformed data
    """
    cache::AA

    """
    The index of the currently loaded slice
    """
    cache_index::Int

    """
    Position of last loaded IFD, updated whenever a slice is appended
    """
    last_ifd_offset::O

    """
    A flag tracking whether this file is editable
    """
    readonly::Bool

    function LazyBufferedTIFF(file::TiffFile{O}, ifds::Vector{IFD{O}}, dims, cache::AA, cache_index::Int, last_ifd_offset::O, readonly::Bool) where {O, AA <: AbstractArray}
        new{eltype(cache), O, typeof(cache)}(file, ifds, dims, cache, cache, cache_index, last_ifd_offset, readonly)
    end
end

function LazyBufferedTIFF(file::TiffFile{O}, ifds::Vector{IFD{O}}) where {O}
    ifd = ifds[1]
    dims = (nrows(ifd), ncols(ifd), length(ifds))
    cache = getcache(ifd)
    LazyBufferedTIFF(file, ifds, dims, cache, -1, zero(O), true)
end

"""
    empty(LazyBufferedTIFF, T, filepath; bigtiff)

Create a new memory-mapped file ready with element type `T` for appending future
slices. The `bigtiff` flag, if true, allows 64-bit offsets for data larger than
~4GB.

```jldoctest; setup=:(rm("test.tif", force=true))
julia> using ColorTypes, FixedPointNumbers # for Gray{N0f8} type

julia> img = empty(LazyBufferedTIFF, Gray{N0f8}, "test.tif"); # make memory-mapped image

julia> push!(img, rand(Gray{N0f8}, 100, 100));

julia> push!(img, rand(Gray{N0f8}, 100, 100));

julia> size(img)
(100, 100, 2)
```
"""
function Base.empty(::Type{LazyBufferedTIFF}, ::Type{T}, filepath; bigtiff=false) where {T <: ColorOrTuple}
    if isfile(filepath)
        error("This file already exists, please use `TiffImages.load` to open")
    end
    LazyBufferedTIFF(T, getstream(format"TIFF", open(filepath, "w+"), filepath); bigtiff = bigtiff)
end

function memmap(t::Type{T}, filepath; bigtiff=false) where {T <: ColorOrTuple}
    Base.depwarn("`memmap` is deprecated, please use empty(LazyBufferedTIFF, $t, $filepath; bigtiff = $bigtiff)", :memmap, force = true)
    empty(LazyBufferedTIFF, t, filepath; bigtiff = bigtiff)
end

function LazyBufferedTIFF(::Type{T}, io::Stream; bigtiff = false) where {T}
    O = bigtiff ? UInt64 : UInt32
    tf = TiffFile{O}(io)

    last_ifd_offset = write(tf) # write out header

    LazyBufferedTIFF(tf, IFD{O}[], (0, 0, 0), Array{T}(undef, 1, 1), -1, O(last_ifd_offset), false)
end

Base.size(A::LazyBufferedTIFF) = A.dims
offset(::LazyBufferedTIFF{T, O, AA}) where {T, O, AA} = O

function Base.getindex(A::LazyBufferedTIFF{T, O, AA}, i1::Int, i2::Int, i::Int) where {T, O, AA}
    (size(A) == (0, 0, 0)) && error("This image has not been initialized, please `push!` data into it first")
    # check the loaded cache is already the correct slice
    if A.cache_index != i
        ifd = ifds(A)[i]

        # if the file isn't open, lets open a handle and update it
        if !isopen(A.file.io)
            path = A.file.filepath
            A.file.io = getstream(format"TIFF", open(path), path)
        end

        read!(A.working_cache, A.file, ifd)

        A.cache = transform(A.working_cache, ifd)

        A.cache_index = i
    end

    return A.cache[i1, i2]
end

function Base.setindex!(A::LazyBufferedTIFF, I...)
    error("Unable to mutate inplace since this array is on disk. Convert to a mutable in-memory version by running "*
          "`copy(arr)`. \n\n𝗡𝗼𝘁𝗲: For large files this can be quite expensive. A future PR will add "*
          "support for writing inplace to disk. See `push!` for appending to an array.")
end

"""
    push!(img::LazyBufferedTIFF, slice::AbstractMatrix)

Push a 2D slice to a memory-mapped file. The slice must be the same `eltype` as the
target `img` and the `img` must be not be readonly.
"""
function Base.push!(A::LazyBufferedTIFF{T, O, AA}, data::AbstractMatrix{T}) where {T, O, AA}
    ifd = _constructifd(data, offset(A.file))

    push!(A, DenseTaggedImage(data, ifd))
end

"""
    push!(img::LazyBufferedTIFF, tiff)

Push a 2D slice and associated IFD to a memory-mapped file. The slice must be
the same `eltype` as the target `img`. This allows for writing custom tags to
the file

```jldoctest; setup = :(using TiffImages, ColorTypes, FixedPointNumbers)
julia> slice = TiffImages.DenseTaggedImage(Gray.(zeros(UInt8, 10, 10)));

julia> ifds(slice)[TiffImages.IMAGEDESCRIPTION] = "Custom info";

julia> temp_file = joinpath(mktempdir(), "tmp.tif");

julia> lazy_tiff = empty(LazyBufferedTIFF, Gray{N0f8}, temp_file; bigtiff = true);

julia> push!(lazy_tiff, slice);

julia> close(lazy_tiff) # done writing, close open stream

julia> ifds(TiffImages.load(temp_file))[TiffImages.IMAGEDESCRIPTION] # read from disk
Tag(IMAGEDESCRIPTION, "Custom info")

```
"""
function Base.push!(A::LazyBufferedTIFF{T, O, AA}, tiff::D) where {T, O, AA, D <: AbstractTIFF{T, 2}}
    (A.readonly) && error("This image is read only")
    data = tiff.data

    # merge a minimal IFD with the correct offset with any user provided tags
    ifd = merge(_constructifd(data, offset(A.file)), ifds(tiff))

    if size(A) == (0, 0, 0) # if this is the initial slice pushed, initialize the size
        A.dims = (size(data)..., 0)
    end

    @assert size(data) == (A.dims[1], A.dims[2]) "Pushed slices must have dimensions: $((A.dims[1], A.dims[2]))"

    pagecache = Vector{UInt8}(undef, size(data, 2) * sizeof(T) * size(data, 1))

    if A.last_ifd_offset + sizeof(pagecache) + sizeof(ifd) > typemax(O)
        @info "No more room in file @ N = $(length(ifds(A)))"
    end
    seekend(A.file.io)
    prev_ifd_slice = _writeslice(pagecache, A.file, data, ifd, A.last_ifd_offset)

    # update data
    A.dims = (A.dims[1], A.dims[2], A.dims[3] + 1)
    push!(ifds(A), ifd)
    A.last_ifd_offset = prev_ifd_slice
    A.cache = data
    A.cache_index = A.dims[3]
    A
end

Base.push!(A::DenseTaggedImage{T, N, O, AA}, data) where {T, N, O, AA <: LazyBufferedTIFF} = push!(A.data, data)

function Base.show(io::IO, ::MIME"text/plain", A::LazyBufferedTIFF{T, O, AA}) where {T, O, AA}
    printstyled(io, O == UInt32 ? "32-bit" : "64-bit"; color = :cyan)
    print(io, " LazyBufferedTIFF{$(T)} ")
    printstyled(io, "$(size(A, 1))×$(size(A, 2))×$(size(A, 3))"; bold=true)
    if A.readonly
        printstyled(io, " (readonly)"; color=:red)
    else
        printstyled(io, " (writable)"; color=:green)
    end
    println(io)
    ondisk = sizeof(A.file)
    ondisk += (size(A) == (0, 0, 0)) ? 0 : sum(sizeof.(ifds(A))) + sizeof(T) * reduce(*, size(A))
    println(io, "    Current file size on disk:   $(Base.format_bytes(ondisk))")
    println(io, "    Addressable space remaining: $(Base.format_bytes(typemax(O) - ondisk))")
end

Base.close(tiff::L) where {L <: LazyBufferedTIFF} = close(tiff.file.io)

using Documenter
using DemoCards
using TiffImages

using Literate
using Images

EXAMPLE_DIR = joinpath(@__DIR__, "..", "examples")
EXAMPLES = filter(x->endswith(x, ".jl"), joinpath.(EXAMPLE_DIR, readdir(EXAMPLE_DIR)))
OUTPUT = joinpath(@__DIR__, "src", "examples")

for ex in EXAMPLES
    Literate.markdown(ex, OUTPUT, documenter = true)
end

demopage, postprocess_cb, demo_assets = makedemos("demos") # this is the relative path to docs/
assets = []
isnothing(demo_assets) || (push!(assets, demo_assets))

DocMeta.setdocmeta!(TiffImages, :DocTestSetup, :(using TiffImages); recursive=true)
makedocs(
    format = Documenter.HTML(
        prettyurls=get(ENV, "CI", "false") == "true",
        assets =vcat([
                asset("https://stats.tamasnagy.com/script.js", class=:js, attributes=Dict(Symbol("data-website-id") => "63767397-8027-4beb-aca4-f8b6dba045e1", :defer => ""))
            ], assets),
    ),
    modules=[TiffImages],
    sitename="TiffImages.jl",
    authors="Tamas Nagy and contributors",
    warnonly = true,
    pages = [
        "Home" => "index.md",
        "Examples" => [
            "Reading TIFFs" => joinpath("examples", "reading.md"),
            "Writing TIFFs" => joinpath("examples", "writing.md"),
            "Lazy TIFFs" => joinpath("examples", "mmap_lazyio.md")
        ],
        demopage,
        "Library" => [
            "Public" => joinpath("lib", "public.md"),
            "Extending" => [
                "Overview" => joinpath("lib", "extend", "index.md"),
                "Built-in Tags" => joinpath("lib", "extend", "tags.md"),
            ],
        ],
        "Contributing" => "contributing.md"
    ]
)

postprocess_cb()

deploydocs(
    repo = "github.com/tlnagy/TiffImages.jl.git",
    push_preview = true
)

@testset "Interpretations" begin
    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.BITSPERSAMPLE] = [16]
    ifd[TiffImages.SAMPLEFORMAT] = [3]
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.SAMPLESPERPIXEL] = 1

    @test TiffImages.interpretation(ifd) == Gray{Float16}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.SAMPLESPERPIXEL] = 2
    ifd[TiffImages.BITSPERSAMPLE] = [32, 32]
    ifd[TiffImages.SAMPLEFORMAT] = [3, 3]

    @test TiffImages.interpretation(ifd) == TiffImages.WidePixel{Gray{Float32}, Tuple{Float32}}

    # handle case where SamplesPerPixel is missing, issue #56
    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.BITSPERSAMPLE] = [8]

    @test TiffImages.interpretation(ifd) == Gray{N0f8}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.SAMPLESPERPIXEL] = 2
    ifd[TiffImages.BITSPERSAMPLE] = [8, 8]
    ifd[TiffImages.SAMPLEFORMAT] = [2, 2]
    ifd[TiffImages.EXTRASAMPLES] = TiffImages.EXTRASAMPLE_ASSOCALPHA

    @test TiffImages.interpretation(ifd) == GrayA{Q0f7}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.SAMPLESPERPIXEL] = 2
    ifd[TiffImages.BITSPERSAMPLE] = [8, 8]
    ifd[TiffImages.SAMPLEFORMAT] = [2, 2]
    ifd[TiffImages.EXTRASAMPLES] = TiffImages.EXTRASAMPLE_UNASSALPHA

    @test TiffImages.interpretation(ifd) == TiffImages.WidePixel{Gray{Q0f7}, Tuple{Q0f7}}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.SAMPLESPERPIXEL] = 2
    ifd[TiffImages.BITSPERSAMPLE] = [8, 8]
    ifd[TiffImages.SAMPLEFORMAT] = [1, 1]
    ifd[TiffImages.EXTRASAMPLES] = TiffImages.EXTRASAMPLE_UNSPECIFIED

    @test TiffImages.interpretation(ifd) == TiffImages.WidePixel{Gray{N0f8}, Tuple{N0f8}}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_MINISBLACK
    ifd[TiffImages.SAMPLESPERPIXEL] = 3
    ifd[TiffImages.BITSPERSAMPLE] = [12, 13, 14]
    ifd[TiffImages.SAMPLEFORMAT] = [1, 1, 1]
    ifd[TiffImages.EXTRASAMPLES] = [0, 0]

    @test TiffImages.interpretation(ifd) == TiffImages.WidePixel{Gray{N4f12}, Tuple{N3f13, N2f14}}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.SAMPLESPERPIXEL] = 3
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_RGB
    ifd[TiffImages.SAMPLEFORMAT] = [1, 1, 1]
    ifd[TiffImages.BITSPERSAMPLE] = [12, 12, 12]

    @test TiffImages.interpretation(ifd) == RGB{N4f12}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_RGB
    ifd[TiffImages.SAMPLESPERPIXEL] = 4
    ifd[TiffImages.BITSPERSAMPLE] = [8, 8, 8, 8]
    ifd[TiffImages.SAMPLEFORMAT] = [1, 1, 1, 1]
    ifd[TiffImages.EXTRASAMPLES] = TiffImages.EXTRASAMPLE_UNSPECIFIED

    @test TiffImages.interpretation(ifd) == TiffImages.WidePixel{RGB{N0f8}, Tuple{N0f8}}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_RGB
    ifd[TiffImages.SAMPLESPERPIXEL] = 4
    ifd[TiffImages.BITSPERSAMPLE] = [8, 8, 8, 8]
    ifd[TiffImages.SAMPLEFORMAT] = [1, 1, 1, 1]
    ifd[TiffImages.EXTRASAMPLES] = TiffImages.EXTRASAMPLE_ASSOCALPHA

    @test TiffImages.interpretation(ifd) == RGBA{N0f8}

    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.PHOTOMETRIC] = TiffImages.PHOTOMETRIC_RGB
    ifd[TiffImages.SAMPLESPERPIXEL] = 6
    ifd[TiffImages.BITSPERSAMPLE] = [16, 16, 16, 16, 16, 16]
    ifd[TiffImages.SAMPLEFORMAT] = [1, 1, 1, 1, 1, 1]
    ifd[TiffImages.EXTRASAMPLES] = [1, 0, 2]

    @test TiffImages.interpretation(ifd) == TiffImages.WidePixel{RGBA{N0f16}, Tuple{N0f16, N0f16}}
end

@testset "Sample Types" begin
    @test TiffImages.bitspersample(RGB{Float32}) == [32, 32, 32]
    @test TiffImages.bitspersample(RGB{N1f7}) == [7, 7, 7]
    @test TiffImages.bitspersample(RGB{Q4f11}) == [12, 12, 12]
    @test TiffImages.bitspersample(TiffImages.WidePixel{RGB{N0f16}, Tuple{N0f16, N0f16}}) == [16, 16, 16, 16 ,16]

    @test TiffImages.sampleformat(RGB{Float32}) == [3, 3, 3]
    @test TiffImages.sampleformat(RGB{N1f7}) == [1, 1, 1]
    @test TiffImages.sampleformat(RGB{Q4f11}) == [2, 2, 2]
    @test TiffImages.sampleformat(TiffImages.WidePixel{RGB{N0f16}, Tuple{N0f16, N0f16}}) == [1, 1, 1, 1, 1]

    @test TiffImages.extrasamples(RGBA{Float64}) == 1
    @test TiffImages.extrasamples(RGB{Float64}) == nothing
    @test TiffImages.extrasamples(TiffImages.WidePixel{RGBA{Float64}, Tuple{Float64, Float64}}) == [1, 0, 0]
    @test TiffImages.extrasamples(TiffImages.WidePixel{RGB{Float64}, Tuple{Float64, Float64}}) == [0, 0]
end

import .Iterators: partition

"""
    $(SIGNATURES)

Loads a TIFF image. Optional flags `verbose`, `lazyio`, and `mmap` are set to
true, false, and false by default, respectively. Setting `verbose` to false
will hide the loading bar, while setting either `lazyio` or `mmap` to true
defer loading until the data are needed (by either of two mechanisms).

Parallelism is enabled by default, but can be disabled by setting
`JULIA_IMAGES_PARALLEL`=false in your environment

Loading images with a large number of channels may result in a noticeable delay
on the first load (up to several minutes for hundreds or thousands of channels)

See [Lazy TIFFs](@ref) for more details about memory-mapping and lazy I/O.
"""
function load(filepath::String; mode = "r", kwargs...)
    _safe_open(filepath, mode) do io
        load(io; kwargs...)
    end
end

load(io::IOStream; kwargs...) = load(read(io, TiffFile); kwargs...)
function load(tf::TiffFile; verbose=true, mmap = false, lazyio = false)
    ifds = IFD{offset(tf)}[]

    nplanes = 0
    for ifd in tf
        load!(tf, ifd)
        push!(ifds, ifd)
        nplanes += 1
    end

    homogeneous = is_homogeneous(ifds)

    ifd = first(ifds)
    if mmap && iscontiguous(ifd) && getdata(CompressionType, ifd, COMPRESSION, COMPRESSION_NONE) === COMPRESSION_NONE
        return MmappedTIFF(tf, ifds)
    elseif lazyio || mmap
        homogeneous || error("lazy IO is only supported for homogeneous files")
        mmap && @warn "Compression and discontiguous planes are not supported by `mmap`, use `lazyio = true` instead"
        loaded = LazyBufferedTIFF(tf, ifds)
    else
        if nplanes == 1
            loaded = load(tf, ifds, nothing; verbose=verbose)
        else
            loaded = load(tf, ifds, nplanes, Val(homogeneous); verbose=verbose)
        end
    end

    if (tf.need_bswap && !is_irregular_bps(ifd)) || predictor(ifd) == 3
        @debug "bswap'ing data"
        if !homogeneous
            for sub in loaded
                sub .= _bswap.(sub)
            end
        else
            loaded .= _bswap.(loaded)
        end
    end

    close(tf.io)

    if nplanes > 1 && !homogeneous
        # multiple images of different sizes or color types
        data = fixcolors.(loaded, ifds)
        return StridedTaggedImage(data, ifds)
    else
        data = fixcolors(loaded, first(ifds))
        return DenseTaggedImage(data, ifds)
    end
end

"""
    fixcolors(loaded, ifd)

Wrap the raw eltype of an image with color if needed, e.g. for space efficient
on-disk representations like palette-colored images. Otherwise, just return the passed image.
"""
function fixcolors(loaded, ifd)
    if eltype(loaded) <: Palette
        raw = rawtype(ifd)
        loadedr = reinterpret(raw, loaded)
        maxdepth = 2^(Int(ifd[BITSPERSAMPLE].data))-1
        colors = ifd[COLORMAP].data
        color_map = vec(reinterpret(RGB{N0f16}, reshape(colors, :, 3)'))
        return IndirectArray(loadedr, OffsetArray(color_map, 0:maxdepth))
    else
        return loaded
    end
end

function load(tf::TiffFile, ifds::AbstractVector{<:IFD}, ::Nothing; verbose = true)
    ifd = first(ifds)

    cache = _getcache(ifd)
    read!(cache, tf, ifd)
    Matrix(transform(cache, ifd))
end

function load(tf::TiffFile, ifds::AbstractVector{<:IFD}, N, homogeneous::Val{true}; verbose = true)
    ifd = first(ifds)

    cache = _getcache(ifd)

    data = similar(cache, nrows(ifd), ncols(ifd), N)

    @showprogress desc="Loading:" enabled=verbose for (idx, ifd) in enumerate(ifds)
        read!(cache, tf, ifd)
        data[:, :, idx] .= transform(cache, ifd)
    end

    return data
 end

function load(tf::TiffFile, ifds::AbstractVector{<:IFD}, N, homogeneous::Val{false}; verbose = true)
    data = Vector{AbstractMatrix}()

    @showprogress desc="Loading:" enabled=verbose for (idx, ifd) in enumerate(ifds)
        cache = _getcache(ifd)
        read!(cache, tf, ifd)
        push!(data, transform(cache, ifd))
    end

    return data
end

function _getcache(ifd)
    spp = nsamples(ifd)
    if spp > 100
        @info "loading image with $spp channels; this may take up to a few minutes"
    end

    getcache(ifd)
end

transform(cache, ifd) = istiled(ifd) ? tile(cache, ifd) : cache'

function tile(cache, ifd)
    rows = nrows(ifd)
    cols = ncols(ifd)
    width = tilecols(ifd) # width of a tile
    height = tilerows(ifd) # height of a tile
    tileswidth = cld(cols, width) # number of tiles in a row
    tilesheight = cld(rows, height) # number of tiles in a column
    tilesize = width * height # number of pixels in a tile

    # tiles are encoded linearly; we need to reshape each strip into a tile and ...
    tiles = adjoint.(reshape.(partition(cache, tilesize), width, height))

    # ... arrange the tiles to get a padded image, which needs to be ...
    padded_image = vcat(map(row -> hcat(row...), partition(tiles, tileswidth))...)

    # ... cropped because the encoded image is padded to tile boundaries
    padded_image[1:rows, 1:cols]
end

# # Writing TIFFs

# This page is a tutorial for saving TIFFs using TiffImages.jl and covers some common
# use cases

#md # ```@contents
#md # Pages = ["writing.md"]
#md # Depth = 5
#md # ```

# You might want to write TIFFs to disk too. Now this can be done quite simply
# with TiffImages.jl. Say you have some AbstractArray type that you want to save, here
# we'll call it `data`:

using Random
using Images # for nice inline images

Random.seed!(123)
data = rand(RGB{N0f8}, 10, 10)

#md # !!! note
#md #     TiffImages.jl only works with AbstractArrays with `eltype`s of `<:ColorOrTuple` because
#md #     the writer needs to know how to represent the image data on disk. Make sure to
#md #     convert your `AbstractArrays` using before passing them. See the
#md #     [common strategies](#Strategies-for-saving-common-types) section
#md #     below for tips.

# ## Simple cases

# In most simple cases, all you need to do is use the `save` function

using TiffImages
TiffImages.save("test.tif", data)

# That's it! TiffImages will convert your data into its own internal file type
# and then rapidly write it to disk. See the "Incremental writing" section of
# [Lazy TIFFs](@ref) for building a TIFF piece by piece.

# ## Complex cases
# If you need more fine-grained control over what tags are included when the
# image is written, this section is for you!

# ### Converting to `TiffImages.jl`'s TIFF type
# Next lets convert `data` to a TIFF type

using TiffImages
img = TiffImages.DenseTaggedImage(data)

# Wait nothing happened! Hang with me, lets take a closer look at our new object
# using the `dump` command. We can see that there's now new information
# associated with our data! TiffImages.jl usually represents TIFF images as simply the
# data and associated tags that describe the data

dump(img; maxdepth=1)

# The tags are organized as a vector of what are called [Image File
# Directories](https://www.awaresystems.be/imaging/tiff/faq.html) (IFDs). For a
# simple 2D image like what we have, the IFDs will be stored a vector of
# length=1. For 3D images, the length of the IFDs vector will equal the length
# of the image in the third dimension.

# Lets take a look at what tags there are:

ifd = ifds(img) # returns a single IFD since our data is 2D

# ### Manipulating TIFF Tags
#
# These are some of the most basic tags that are required by the TIFF spec. We
# can even update it to add our own custom tags

ifd[TiffImages.IMAGEDESCRIPTION] = "This is very important data"
ifd

# We can even add tags that aren't in the standard set in
# [`TiffImages.TiffTag`](@ref) as long as they are a `UInt16`

ifd[UInt16(34735)] = UInt16[1, 2, 3]
ifd

# We can also delete tags if we decide we don't want them:

delete!(ifd, TiffImages.IMAGEDESCRIPTION)
ifd

#md # !!! warning
#md #     Careful with `delete!`, if any of core tags are deleted, TiffImages.jl and
#md #     other readers might fail to read the file


# ### Saving to disk
#
# Once you're happy with your TIFF object, you can write it to disk as follows:

TiffImages.save("test.tif", img)

# And to just double check, we can load it right back in

TiffImages.load("test.tif")

# ## Strategies for saving common types

# The general strategy for saving arrays will differ a bit depending on the
# type. The key step is the convert or reinterpret the arrays so that the
# elements are subtypes of `ColorOrTuple`

# #### Unsigned Integers

# Say you want to save a 3D array of small integers as grayscale values.

data2 = rand(UInt8.(1:255), 5, 10)
eltype(data2)

# You can't directly save the `data2` since TiffImages.jl needs some color information
# to properly save the file. You can use
# [`reinterpret`](https://docs.julialang.org/en/v1/base/arrays/#Base.reinterpret)
# to accomplish this:

grays = reinterpret(Gray{N0f8}, data2)
img2 = TiffImages.DenseTaggedImage(grays)

# Here the data are first reinterpreted as `N0f8`s, which is a
# [`FixedPointNumber`](https://github.com/JuliaMath/FixedPointNumbers.jl) then
# wrapped with a Gray type that marks this as a grayscale image. TiffImages.jl uses
# this information to update the TIFF tags

# #### Floating point numbers

# With RGB we can reinterpret the first dimension of a 3D array as the 3
# different color components (red, green, and blue):

data = rand(Float64, 3, 5, 10);
colors = dropdims(reinterpret(RGB{eltype(data)}, data), dims=1) # drop first dimension
img3 = TiffImages.DenseTaggedImage(colors)

# Here we dropped the first dimension since it was collapsed into the RGB type
# when we ran the `reinterpret` command.

# #### Signed integers

# Say you want to save data that has negative integer values. In that case, you
# can't use `N0f8`, etc because those only worked for unsigned integers. You
# have to instead use `Q0f63`, etc, which is a different kind of fixed point
# number that uses one bit for the sign info (that's why it's `Q0f63`, not `Q0f64`!)

data = rand(-100:100, 5, 5)
#--------------------------
img4 = TiffImages.DenseTaggedImage(reinterpret(Gray{Q0f63}, data))
println(ifds(img4))

# As you can see the `SAMPLEFORMATS` and `BITSPERSAMPLE` tags correctly updated
# to show that this TIFF contains signed integers and 64-bit data, respectively.

#md # !!! warning
#md #     Currently, several of the display libraries struggle with showing
#md #     `Colorant`s backed by a signed type so you might run into errors, but
#md #     the data will still save properly

struct StridedTaggedImage{O <: Unsigned, AA <: AbstractMatrix} <: AbstractTIFF{Any, 1}
    data::Vector{AA}
    ifds::Vector{IFD{O}}
end

Base.size(t::StridedTaggedImage) = size(t.data)
Base.getindex(img::StridedTaggedImage, i) = getindex(img.data, i)

"""
    $(TYPEDEF)

A type to represent memory-mapped TIFF data, returned by `TiffImages.load(filepath; mmap=true)`.
Useful for opening and operating on images too large to store in memory.

This works by exploiting the operating system's memory-mapping capabilities. This is not compatible
with certain TIFF options, including compression, but when applicable it gives good performance for
most access (indexing) patterns.
See discussion in the package documentation, and [`LazyBufferedTIFF`](@ref) for an alternative
with different strengths and weaknesses.

```
julia> using TiffImages

julia> img = TiffImages.load(filepath; mmap=true);

julia> print(summary(img))
200×541 TiffImages.MmappedTIFF{RGBA{N0f8}, 2}
```

Fields:

$(FIELDS)
"""
struct MmappedTIFF{T <: ColorOrTuple, N, O <: Unsigned, A <: AbstractMatrix{T}} <: AbstractTIFF{T, N}
    """
    2d slices in the file
    """
    chunks::Vector{A}
    """
    The associated tags for each slice in this array
    """
    ifds::Vector{IFD{O}}
    """
    The 2d slice size
    """
    sz2::Dims{2}
end

function MmappedTIFF{T,N}(file::TiffFile{O}, ifds::Vector{IFD{O}}) where {T, N, O <: Unsigned}
    N ∈ (2, 3) || error("only 2d and 3d TIFF arrays are supported")
    if N == 2
        length(ifds) == 1 || error("2d files must have a single Image File Directory")
    end
    ifd = first(ifds)
    sz = (nrows(ifd), ncols(ifd))
    compression = getdata(CompressionType, ifd, COMPRESSION, COMPRESSION_NONE)
    compression == COMPRESSION_NONE || error("mmap is not yet supported with compression")
    all(iscontiguous, ifds) || error("non-contiguous TIFFs are not yet supported by mmap")

    seek(file, 0)
    rawio = stream(file)
    raw = Mmap.mmap(rawio, Vector{UInt8}, filesize(rawio))
    chunks = [getchunk(T, raw, reverse(sz), ifd) for ifd in ifds]
    return MmappedTIFF{T, N, O, eltype(chunks)}(chunks, ifds, sz)
end

function MmappedTIFF{T}(file::TiffFile{O}, ifds::Vector{IFD{O}}) where {T, O <: Unsigned}
    l = length(ifds)
    return l == 1 ? MmappedTIFF{T, 2}(file, ifds) : MmappedTIFF{T, 3}(file, ifds)
end

function MmappedTIFF(file::TiffFile{O}, ifds::Vector{IFD{O}}) where {O <: Unsigned}
    ifd = first(ifds)
    pixeltype = interpretation(ifd)
    return MmappedTIFF{pixeltype}(file, ifds)
end

function getchunk(::Type{T}, raw::Vector{UInt8}, sz::Dims{2}, ifd::IFD) where T
    rawsz = sizeof(T) * prod(sz)
    strip_offsets = ifd[STRIPOFFSETS].data
    o = strip_offsets[1]::Core.BuiltinInts
    if sizeof(T) == 1
        return reinterpret(reshape, T, reshape(view(raw, o+1:o+rawsz), sz...))
    end
    return reinterpret(reshape, T, reshape(view(raw, o+1:o+rawsz), sizeof(T), sz...))
end

## AbstractArray interface

chunk1(img::MmappedTIFF) = @inbounds return img.chunks[1]

Base.size(img::MmappedTIFF{T, 2}) where T = img.sz2
Base.size(img::MmappedTIFF{T, 3}) where T = (img.sz2..., length(img.chunks))

Base.@propagate_inbounds Base.getindex(img::MmappedTIFF{T, 2}, i::Int, j::Int) where T = chunk1(img)[j, i]

Base.@propagate_inbounds function Base.getindex(img::MmappedTIFF{T, 3}, i::Int, j::Int, k::Int) where T
    chunk = img.chunks[k]
    return chunk[j, i]
end

# These work only if the file was opened with write permissions
Base.@propagate_inbounds Base.setindex!(img::MmappedTIFF{T, 2}, val, i::Int, j::Int) where T = chunk1(img)[j, i] = val

Base.@propagate_inbounds function Base.setindex!(img::MmappedTIFF{T, 3}, val, i::Int, j::Int, k::Int) where T
    chunk = img.chunks[k]
    chunk[j, i] = val
end

function Base.summary(io::IO, X::MmappedTIFF)
    print(io, Base.dims2string(size(X)), " TiffImages.MmappedTIFF{$(eltype(X)), $(ndims(X))}")
    n = length(X.chunks)
    if n > 1
        print(io, " with $(length(X.chunks)) slice planes")
    end
end

# ---
# title: Loading a remote TIFF
# description: This demo shows how to load a TIFF over the network
# author: Santiago Pelufo, Tamas Nagy
# cover: assets/coffee.png
# ---

# The following code can be used to load remote TIFFs without saving them to the
# disk. 

using TiffImages, Downloads, FileIO

function load_tiff_without_saving(url)
  buffer = IOBuffer()
  Downloads.download(url, buffer)
  bufstream = TiffImages.getstream(format"TIFF", buffer)
  TiffImages.load(read(bufstream, TiffFile))
end

# We'll load an example from
# [`tlnagy/exampletiffs`](https://github.com/tlnagy/exampletiffs) 

coffeepath = "https://github.com/tlnagy/exampletiffs/raw/11516d288c4b03a258aa3027705b0e9d2ce2b5de/coffee.tif"
coffeeimg = load_tiff_without_saving(coffeepath)

# No disks involved!

save("assets/coffee.png", collect(coffeeimg[:, 70:470])) #hide
nothing #hide

using ColorTypes
using ColorVectorSpace
using Documenter
using FixedPointNumbers
using OffsetArrays
import AxisArrays: AxisArray # No, we don't want to import `AxisArrays.axes`
using Statistics
using Test
using TiffImages

include("Aqua.jl")

DocMeta.setdocmeta!(TiffImages, :DocTestSetup, :(using TiffImages); recursive=true)
doctest(TiffImages)

_wrap(name) = "https://github.com/tlnagy/exampletiffs/blob/master/$name?raw=true"

using Downloads
get_example(x) = Downloads.download(_wrap(x))

@testset "Tag loading" begin
    include("tags.jl")
end

@testset "Gray with ExtraSample" begin
    filepath = get_example("house.tif")
    img = TiffImages.load(filepath)
    @test size(img) == (512, 512)
    @test eltype(img) == GrayA{N0f8}
    @test img[50,50] == GrayA{N0f8}(0.804, 1.0) # value from ImageMagick.jl
    img[50:300, 50:150] .= 0.0
    @test img[50, 50] == GrayA{N0f8}(0.0, 1.0)

    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data
end

@testset "MRI stack" begin
    filepath = get_example("mri.tif")
    img = TiffImages.load(filepath)
    @test size(img) == (128, 128, 27)
    @test eltype(img) == RGB{N0f16}

    # TODO: inefficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt == img.data
    @test img_cvt !== img.data

    @testset "Multiple planes" begin
        # test slice based access
        @test red(img[92, 21, 2]) == 0.74118N0f16

        # make sure IFDs are included if whole slice is grabbed
        @test typeof(ifds(img[:, :, 2])) <: TiffImages.IFD
        @test length(ifds(img[:, :, 2:5])) == 4

        # make sure that subslicing in XY drops IFD info
        @test typeof(img[:, 50:60, 27]) == Array{RGB{Normed{UInt16,16}},2}
    end
end

@testset "Floating point RGB image" begin
    filepath = get_example("spring.tif")
    img = TiffImages.load(filepath)
    @test size(img) == (619, 858)
    @test eltype(img) == RGB{Float16}
    
    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data
end

@testset "Packbits image" begin
    filepath = get_example("coffee.tif")
    img = TiffImages.load(filepath)
    @test size(img) == (378, 504)
    @test eltype(img) == Gray{N0f8}
    
    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data
end

@testset "Adobe Deflate image" begin
    filepath = get_example("underwater_bmx.tif")
    img = TiffImages.load(filepath)
    @test size(img) == (773, 1076)
    @test eltype(img) == RGB{N0f8}

    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data

    # Dirty patch the TIFF_COMPRESSION tag from
    # COMPRESSION_ADOBE_DEFLATE (8) to COMPRESSION_DEFLATE (32946).
    # Those are in fact exactly the same so nothing else needs to be
    # adjusted.
    data = read(filepath)
    @assert data[1063947:1063948] == [0x08, 0x00]
    data[1063947:1063948] .= reinterpret(UInt8, [UInt16(32946)])
    _, io = mktemp()
    write(io, data)
    seekstart(io)
    img = TiffImages.load(io)
    @test size(img) == (773, 1076)
    @test eltype(img) == RGB{N0f8}
end

@testset "Bilevel image" begin
    filepath = get_example("capitol.tif")
    img = TiffImages.load(filepath)
    @test size(img) == (378, 504)
    @test eltype(img) == Gray{N7f1}
    
    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data
end

@testset "Striped bilevel image" begin
    filepath = get_example("capitol2.tif")
    img = TiffImages.load(filepath)
    @test size(img) == (378, 504)
    @test eltype(img) == Gray{N7f1}

    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data
end

@testset "Signed integer type" begin
    filepath = get_example("4D-series.ome.tif")
    img = TiffImages.load(filepath)

    @test size(img) == (167, 439, 35)
    expected_rng = reinterpret.(Q0f7, Int8.((-1, 96)))
    @test extrema(img[:, :, 1]) == expected_rng

    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data
end

@testset "Discontiguous striped image, Issue #38" begin
    filepath = get_example("julia.tif")
    img = TiffImages.load(filepath)

    @test size(img) == (300, 500)
    # if discontiguous striping is broken then the garbage padding data will
    # leak into the actual image
    @test all(img[3, 1:50] .== RGB{N0f8}(1, 1, 1))

    # Efficient convert method
    img_cvt = convert(Array{eltype(img), ndims(img)}, img)
    @test img_cvt === img.data
end

@testset "Issue #12" begin
    @testset "Big endian striped file" begin
        filepath = get_example("flagler.tif")
        img = TiffImages.load(filepath)

        # verify that strip offsets are correctly bswapped for endianness
        img_stripoffsets = Int.(ifds(img)[TiffImages.STRIPOFFSETS].data)
        @test img_stripoffsets == [8, 129848, 259688, 389528]

        # Efficient convert method
        img_cvt = convert(Array{eltype(img), ndims(img)}, img)
        @test img_cvt === img.data
    end

    @testset "Little endian striped file" begin
        filepath = get_example("house.tif")
        img = TiffImages.load(filepath)

        # verify that strip offsets are correctly bswapped for endianness
        img_stripoffsets = Int.(ifds(img)[TiffImages.STRIPOFFSETS].data)
        @test issorted(img_stripoffsets)

        # Efficient convert method
        img_cvt = convert(Array{eltype(img), ndims(img)}, img)
        @test img_cvt === img.data
    end
end

@testset "Mmap & lazyio" begin
    include("mmap_lazyio.jl")
end

@testset "Writing" begin
    include("writer.jl")
end

@testset "Interpreting IFD layouts" begin
    include("layouts.jl")
end

@testset "Issue #69" begin
    rawarray = Gray.(zeros(10, 10, 2))
    ifds = [TiffImages.IFD(UInt64), TiffImages.IFD(UInt64)]
    # test that the constructor can handle small images using 64bit offsets 
    @test size(TiffImages.DenseTaggedImage(rawarray, ifds)) == size(rawarray)
end

@testset "Issue #96" begin
    # Handle TIFFs where multiple slices are stored in the same strip. These are
    # still contiguous since the entire slice is within one strip.
    ifd = TiffImages.IFD(UInt32)
    ifd[TiffImages.IMAGELENGTH] = 16
    ifd[TiffImages.ROWSPERSTRIP] = 256

    @test TiffImages.iscontiguous(ifd)
end

@testset "LZW" begin
    uncompressed = get_example("shapes_uncompressed.tif")
    compressed = get_example("shapes_lzw.tif")
    @test TiffImages.load(uncompressed) == TiffImages.load(compressed)
end

@testset "ZSTD" begin
    uncompressed = get_example("shapes_uncompressed.tif")
    compressed = get_example("shapes_zstd.tif")
    @test TiffImages.load(uncompressed) == TiffImages.load(compressed)
end

@testset "Tiled" begin
    uncompressed = get_example("shapes_uncompressed.tif")
    compressed_tiled = get_example("shapes_lzw_tiled.tif")
    compressed_tiled_multi = get_example("shapes_tiled_multi.tif")
    uncompressed_loaded = TiffImages.load(uncompressed)
    compressed_tiled_multi_loaded = TiffImages.load(compressed_tiled_multi; lazyio=true)
    @test uncompressed_loaded == TiffImages.load(compressed_tiled)
    @test uncompressed_loaded[:] == TiffImages.load(compressed_tiled; lazyio=true)[:]
    @test compressed_tiled_multi_loaded[:,:,1] == uncompressed_loaded
    @test compressed_tiled_multi_loaded[:,:,2] == uncompressed_loaded
    @test compressed_tiled_multi_loaded[:,:,3] == uncompressed_loaded
end

@testset "Planar" begin
    ref = get_example("shapes_uncompressed.tif")
    planar = get_example("shapes_lzw_planar.tif")
    tiled_planar = get_example("shapes_lzw_tiled_planar.tif")
    uncompressed_tiled_planar = get_example("shapes_uncompressed_tiled_planar.tif")
    @test TiffImages.load(ref) == TiffImages.load(planar)
    @test TiffImages.load(ref) == TiffImages.load(tiled_planar)
    @test TiffImages.load(ref) == TiffImages.load(uncompressed_tiled_planar)

    for typ in [Int8,UInt16,Float32]
        for planes in 1:33
            for size in 64:164
                out = Vector{typ}(undef, size * planes)
                a=reduce(vcat,[fill(typ(x),size) for x in 1:planes])
                b=copy(a)
                TiffImages.deplane!(out, a, Val(planes))
                @test a == TiffImages.deplane_slow(b, planes)
            end
        end
    end

    for typ in [Int8,UInt16,Float32]
        for planes in 1:33
            for size in 1:164
                a=reduce(vcat,[fill(typ(x),size) for x in 1:planes])
                b=copy(a)
                TiffImages.deplane!(a, planes)
                @test a == TiffImages.deplane_slow(b, planes)
            end
        end
    end
end

if VERSION < v"1.7"
    partition(s::String, n) = map(xs -> reduce(*, xs), Iterators.partition(s, n))
else
    partition = Iterators.partition
end

@testset "Arbitrary Bit Depth" begin
    ref = TiffImages.load(get_example("shapes_uncompressed.tif"))
    other = TiffImages.load(get_example("shapes_lzw_12bps.tif"))
    m = sum(ref.data .- other.data) ./ length(ref)
    @test m.r < 0.001 && m.g < 0.001 && m.b < 0.001

    @test ifds(other)[TiffImages.BITSPERSAMPLE].data == UInt16[12,12,12]

    other = TiffImages.load(get_example("shapes_lzw_14bps.tif"))
    m = sum(ref.data .- other.data) ./ length(ref)
    @test m.r < 0.001 && m.g < 0.001 && m.b < 0.001

    xs = [rand(UInt8) & 0x7f for _ in 1:160];
    bytes = parse.(UInt8, partition(reduce(*,string.(xs; base=2, pad=7)),8); base=2)
    resize!(bytes, fld(length(bytes) * 8, 7))
    unpacked = TiffImages.unpack_integers_simd(bytes, Val(7))

    @test xs == unpacked

    xs = [rand(UInt32) & 0x1fffffff for _ in 1:256];
    bytes = parse.(UInt8, partition(reduce(*,string.(xs; base=2, pad=29)),8); base=2)
    resize!(bytes, fld(length(bytes) * 32, 29))
    unpacked = TiffImages.unpack_integers_simd(reinterpret(UInt32, bytes), Val(29))

    @test xs == unpacked

    xs = [rand(UInt8) & 0x0f for _ in 1:128];
    bytes = parse.(UInt8, partition(reduce(*,string.(xs; base=2, pad=4)),8); base=2)
    resize!(bytes, fld(length(bytes) * 8, 4))
    unpacked = TiffImages.unpack_integers_simd(bytes, Val(4))

    @test xs == unpacked

    xs = [rand(UInt16) & 0x1ff for _ in 1:124];
    bytes = parse.(UInt8, partition(rpad(reduce(*,string.(xs; base=2, pad=9)), cld(124 * 9, 8) * 8, '0'),8); base=2)
    resize!(bytes, fld(length(bytes) * 16, 9))
    unpacked = TiffImages.unpack_integers_slow(reinterpret(UInt16, bytes), 1, 124, 9)

    @test xs == unpacked

    xs = [rand(UInt32) & 0x7ffffff for _ in 1:124];
    bytes = parse.(UInt8, partition(rpad(reduce(*,string.(xs; base=2, pad=27)), cld(124 * 27, 8) * 8, '0'),8); base=2)
    resize!(bytes, fld(length(bytes) * 32, 27))
    unpacked = TiffImages.unpack_integers(reinterpret(UInt32, bytes), 27)

    @test xs == unpacked
end

@testset "predictor == 3" begin
    original = get_example("shapes_uncompressed.tif")
    encoded = get_example("shapes_lzw_predictor3.tif")
    @test TiffImages.load(original) == TiffImages.load(encoded)
end

@testset "Issue #148" begin
    im = get_example("earthlab.tif")
    @test size(TiffImages.load(im)) == (2400, 2400) # no error
end

@testset "Ragged" begin
    original = TiffImages.load(get_example("shapes_uncompressed.tif"))
    half = TiffImages.load(get_example("shapes_uncompressed_half.tif"))
    palette = TiffImages.load(get_example("shapes_lzw_palette.tif"))
    multisize = TiffImages.load(get_example("shapes_multi_size.tif"))
    multicolor = TiffImages.load(get_example("shapes_multi_color.tif"))

    @test original == multisize[1]
    @test half == multisize[2]

    @test original == multicolor[1]
    @test palette == multicolor[2]
    @test original == multicolor[3]
    @test sum(convert.(Float64, reinterpret(N0f8, original)) .- convert.(Float64, reinterpret(N4f12, multicolor[4]))) ./ (216*128) < 0.0001
    @test original == multicolor[5]
end

@testset "WidePixel" begin
    original = TiffImages.load(get_example("shapes_uncompressed.tif"))
    hyper = TiffImages.load(get_example("shapes_hyper.tif"))

    @test TiffImages.color(hyper) == original
    @test TiffImages.color(original) == original

    @test TiffImages.nchannels(original) == 3
    @test TiffImages.nchannels(hyper) == 7
    @test TiffImages.nchannels(original') == 3
    @test TiffImages.nchannels(hyper') == 7

    @test TiffImages.channel(hyper[100], 4) == 0.1f0
    @test TiffImages.channel(hyper[200], 5) == 0.2f0
    @test TiffImages.channel(hyper[300], 6) == 0.3f0
    @test TiffImages.channel(hyper[400], 7) == 0.5f0

    @test isapprox(sum(sum.(TiffImages.channel.(Ref(original), 1:3))), 23145.05882)
    @test isapprox(sum(sum.(TiffImages.channel.(Ref(hyper), 1:7))), 33282.65886)
end

@testset "Palette color images" begin
    img = TiffImages.load(get_example("poppies.tif"))
    
    @test ifds(img)[TiffImages.BITSPERSAMPLE].data == UInt16(8)
    @test ifds(img)[TiffImages.SAMPLESPERPIXEL].data == UInt16(1)
    @test ifds(img)[TiffImages.PHOTOMETRIC].data == UInt16(TiffImages.PHOTOMETRIC_PALETTE)
end

# Built-in Tags

Tags are stored as an enum called `TiffTag`

```@docs
TiffImages.TiffTag
```

### Full list of built-in tags

```@eval
using TiffImages, Markdown
tags = instances(TiffImages.TiffTag)
mapping = collect.(zip(Int.(tags), string.(tags)))
insert!(mapping, 1, ["Tag ID", "Tag Description"])
Markdown.MD(Markdown.Table(mapping, fill(:l, length(mapping))))
```

# TiffImages.jl

*Pure-Julia TIFF reader and writer with a focus on correctness* 🧐

TIFF (Tagged Image File Format) is a notoriously flexible file format that is
very difficult to support properly so why not just link `libtiff` and call it
a day? Because [Julia developers are
greedy](https://julialang.org/blog/2012/02/why-we-created-julia/). I wanted to
design a clean, minimal, and standards-compliant TIFF reader and writer that can
have the speed and compliance of `libtiff` while adding modern features like
streaming, out-of-memory support, and fancy color support. I wanted to design it
to be extensible such that packages like
[`OMETIFF.jl`](https://github.com/tlnagy/OMETIFF.jl) can hook right in with
minimal overhead. I wanted to leverage the wonderful Julia Arrays ecosystem to
do as much lazily and flexibly as possible.

## Features

TiffImages.jl supports:

- The TIFF 6.0 baseline spec
- Thorough testing
- HDR images stored as 32bit or 64bit floats
- BigTIFF standard (TIFFs larger than 4 GB)
- Memory-mapped and lazy loading/writing
- Arbitrary bit depths (e.g. 12 or 14 bit cameras)
- Common compression algorithms like LZW and Packbits

## Usage

Check out the examples to see how to use `TiffImages.jl`

```@contents
Pages = ["examples/reading.md", "examples/writing.md", "examples/mmap_lazyio.md"]
Depth = 1
```

# Public interface

### Reading/Writing

```@docs
TiffImages.load
TiffImages.save
TiffImages.color
TiffImages.nchannels
TiffImages.channel
```

### Output Types

```@docs
TiffImages.DenseTaggedImage
TiffImages.LazyBufferedTIFF
TiffImages.MmappedTIFF
```

# Contributing

Supporting all TIFFs is non-trivial and I would greatly appreciate any help from
the community in identifying edge cases.

## Add edge case TIFFs

There is incredible diversity in the TIFF ecosystem so much so that there is a
backronym "Thousand Incompatible File Formats" to describe it. I have tried to
establish a good baseline test set of TIFFs that should guarantee that `TiffImages.jl`
should "just work tm" for most people, but if you have a TIFF that you run into
that breaks `TiffImages.jl` please do the following:

1. create a pull request against the
   [example TIFF](https://github.com/tlnagy/exampletiffs) repo adding the file.
   The smaller the file, the better.
2. update the README table with license information, etc.
3. Open an issue against `TiffImages.jl` with the error message and the expected result

# Extending TiffImages.jl

If you want to extend `TiffImages.jl` to add support for more features or change how
TIFF data is loaded, you have come to right place.

### Types

```@docs
TiffImages.TiffFile
TiffImages.IFD
TiffImages.Tag
TiffImages.Iterable
TiffImages.RemoteData
```

### Functions

```@docs
TiffImages.load!
TiffImages.sizeof
```
